<?php 
// affichage de l'entête Html, de la bannière et du menu dynamique
include('lib/lib.php');
$bdd = ouvreBase();
initBase($bdd);
include('lib/ban-menu.php'); 
autorise(array(5,9));			// contrôle accès autorisé pour admin et gestionnaire

DEFINE ('gestionorphelinsLegende','<th>Id</th><th>IdPere</th><th>Texte</th>');
DEFINE ('gestionorphelinsListe',' orphelins listés sur ');
DEFINE ('gestionorphelinsListe1',' lus');
DEFINE ('gestionorphelinsSupprime',' orphelins supprimés sur ');
DEFINE ('gestionorphelinsKO','Erreur ! Rien n\'a été enregistré !');
DEFINE ('gestionorphelinsTitre','<h4>Gestion des orphelins</h4>');
DEFINE ('gestionorphelinsGuide','<p>Les orphelins sont des objets ou fiches n\'ayant aucune relation avec d\'autres objets ou fiches.<br>Ils ne gênent pas le fonctionnement et peuvent être gardés dans l\espoir de les réutiliser plus tard.<br>Néanmoins en nombre ils peuvent encombrer l\'application. <br>Ce programme permet de les lister ou encore de les supprimer.<br>Le nombre d\'objets ou de fiches balayées est limité par la limite maxlus=');
DEFINE ('gestionorphelinsLister','Lister');
DEFINE ('gestionorphelinsSupprimer','Supprimer');

function lireTables($bdd,$table,$limite,$debut) {
 $options = array();
 $reponse = $bdd->query("SELECT Id FROM ".$table." LIMIT ".$limite." OFFSET ".$debut." ;") or die(print_r($bdd->errorInfo()));
 $i=0;
 while ($donnees = $reponse->fetch())  {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 return $options;
}

// afficher liste des orphelins
if (isset($_POST['lister']) ) {
 $limite = $maxlus;
 $debut = $IdRacRel;
 $options = lireTables($bdd,'objet',$limite,$debut);
 $nbo = count($options);
 $list = 0;
 $legende = gestionorphelinsLegende;
 echo '<table border="1"><tr>'.$legende.'</tr>';
 for ($o=0;$o<$nbo;$o++) {
   $id = $options[$o][0];
   $composes = selectCompose($bdd,$id);		// l'objet est-il référencé comme composé dans relation ?
   $nb = count($composes);
   $composants = selectComposant($bdd,$id);	// l'objet est-il référencé comme composant dans relation ?
   $nb = $nb + count($composants);
   if ($nb == 0) {
     $objets = selectId($bdd,$id);
     echo '<tr>';
     afficheRangTable('','','texte',5,$objets[0],'Readonly','d');
     $idpere = selectIdPere($bdd,$id);
     $peres = selectId($bdd,$idpere);
     afficheRangTable('','','texte',30,$objets[1].' '.$peres[3],'ReadOnly','d');
     afficheRangTable('','','texte',50,$objets[3],'Readonly','d');
     echo '</tr>';
    $list++;
   }
  }
  echo '</table>';
  $_POST['message'] = $list.gestionorphelinsListe.$nbo.gestionorphelinsListe1;	// informe l'utilisateur
}

// supprimer les orphelins trouvés
if (isset($_POST['supprimer']) ) {
//print_r($_POST);
 try {
  $bdd->beginTransaction(); 					// ouvre une transaction
  $limite = $maxlus;
  $debut = $IdRacRel;
  $options = lireTables($bdd,'objet',$limite,$debut);
  $nbo = count($options);
  $supp = 0;
  for ($o=0;$o<$nbo;$o++) {
   $id = $options[$o][0];
   $composes = selectCompose($bdd,$id);
   $nb = count($composes);
   $composants = selectComposant($bdd,$id);
   $nb = $nb + count($composants);
   if ($nb == 0) {
    deleteObjet($bdd,$id);
    $supp++;
   }
  }
  $bdd->commit(); 					// valide la transaction
  $_POST['message'] = $supp.gestionorphelinsSupprime.$nbo.gestionorphelinsListe1;	// informe l'utilisateur
 }
 catch(Exception $e) {						// si incident durant l'essai
  $bdd->rollback();						// invalide la transaction
  $_POST['message'] = gestionorphelinsKO;	// informe l'utilisateur
 }
}

echo '<form method="POST" action="gestionorphelins.php">';
echo gestionorphelinsTitre;
echo gestionorphelinsGuide.$maxlus.'</p><br>';
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
$lister = gestionorphelinsLister;
$supprimer = gestionorphelinsSupprimer;
echo '<hr>&nbsp;<input type="submit" name="lister" value="'.$lister.'" />';
echo '&nbsp;<input type="submit" name="supprimer" value="'.$supprimer.'" />';

?>
</p>
<?php
include('lib/pied.php');
?>
