<?php
//error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING);		// invalide erreur NOTICE et WARNING
// marqueur des liens
// utilisé par r1fiche,r2fiche,r2objet
$mrq = '-> ';

// fonction de vérification d'une adresse email (inutile en Html5)
// utilisé par veriflogin.php
function verifEmail($email) {
 $motif='#^[0-9a-z._-]+@{1}[0-9a-z.-]{2,}[.]{1}[a-z]{2,6}$#i';
 if(preg_match($motif,$email))  
  return true;  
 else  
  return false;
}

// fonction d'autorisation d'un programme selon le profil
// si la fonction n'est pas appelée, le programme est autorisé quel que soit le profil 
// Utilisé par tous
function autorise($profils) {
 $nbprofil = count($profils);
 $autorise = FALSE;
 for ($i=0;$i<$nbprofil;$i++) {
  if ($profils[$i] == $_SESSION['profil'] OR $profils[$i] == 0) {
   $autorise = TRUE;
  }
 }
 if (!$autorise) {
  die('<b>Action non autorisée</b><br><br>Veuillez choisir une option du menu.');
 }
}

// pour protéger les quotes et doubles quotes
function protegeQuotes($str) {
 $texte = addslashes($str);
return $texte;
}

// fonction générique d'affichage d'un champ Html précédé de son label
function afficheChamp($label,$nomfor,$typechamp,$taille,$options,$suite,$ro) {
 // si $typechamp est text ou absent, génére un input type=text
 //  si $option commence par Erreur ! affiche en rouge
 //  si $option commence par Attention ! affiche en bleu
 //  si option autre affiche en vert
 // si $typechamp est select, génére un select option
 // si typechamp est checkbox, génère une case à cocher
 // si typechamp est area, génère une zone texte
 // si typechamp est password, génère un champ passe (non visible)
 // si typechamp est date, génère un champ date avec aide
 // si typechamp est button, génère un bouton
 // si $typechamp est ... à développer
 // $nomfor devient le name et le for/id
 // $label est le texte du label du champ
 // $options est un tableau des options possibles pour un select ou la valeur par défaut si text
 // $suite est un espace ou un <br /> (par défaut)
 // $ro = Readonly, ou non renseigné Champ à saisir --OK--
 // Utilisé par tous
 $style = "";
 if ($suite != ' ') 
  $suite ='<br />';
 if ($typechamp == 'select') {
  echo '<label for="'.$nomfor.'">'.$label.'</label>';
  echo '<select id="'.$nomfor.'" name="'.$nomfor.'">';
  for ($i=0;$i<count($options);$i++) {
   $value = $options[$i][0];
   $valeur = $options[$i][1];
   $selected = ''; 
   if (isset($options[0][2]) AND $options[$i][0] == $options[0][2]) 
    $selected='selected';
   echo '<option value="'.$value.'" '.$selected.'>'.$valeur.'</option>';	
  }
  echo '</select>'.$suite;
 }
 elseif ($typechamp == 'checkbox') {
  echo '<label for="'.$nomfor.'">'.$label.'</label><input id="'.$nomfor.'" name="'.$nomfor.'" type="checkbox" value="'.$options.'"/>'.$suite;	
 }
 elseif ($typechamp == 'area') {
  echo '<label for="'.$nomfor.'">'.$label.'</label>';
  echo '<textarea name="'.$nomfor.'" id="'.$nomfor.'" rows="'.$taille.'" cols="80" '.$ro.'>'.$options.'</textarea>'.$suite;	
 }
 elseif ($typechamp == 'password') {
   echo '<label for="'.$nomfor.'">'.$label.'</label><input style="'.$style.'" id="'.$nomfor.'" name="'.$nomfor.'" type="password" size ="'.$taille.'" '.$ro.'/>'.$suite;
 }
 elseif ($typechamp == 'date') { // pas de différence avec type text pour l'instant
  echo '<label for="'.$nomfor.'">'.$label.'</label><input id="'.$nomfor.'" name="'.$nomfor.'" type="text" size ="'.$taille.'" value="'.$options.'" '.$ro.'/>'.$suite;   
 }
 elseif ($typechamp == 'button') {
  echo '<label for="'.$nomfor.'">'.$label.'</label><input id="'.$nomfor.'" name="'.$nomfor.'" type="button" size ="'.$taille.'" value="'.$options.'" '.$ro.'/>'.$suite; 
 }
 elseif ($typechamp == 'submit') {
  echo '<label for="'.$nomfor.'">'.$label.'</label><input id="'.$nomfor.'" name="'.$nomfor.'" type="submit" size ="'.$taille.'" value="'.$options.'" '.$ro.'/>'.$suite; 
 }
 else {
// cas du champ text
  if (substr($options,0,8) == 'Erreur !') { // affiche message d'erreur en rouge
	$style = 'color:red;';
  }
  elseif (substr($options,0,11) == 'Attention !') { // affiche message d'alerte en bleu
	$style = 'color:blue;';
  }
  else {
	$style ='';
  }
  echo '<label for="'.$nomfor.'">'.$label.'</label><input style="'.$style.'" id="'.$nomfor.'" name="'.$nomfor.'" type="text" size ="'.$taille.'" value="'.$options.'" '.$ro.'/>'.$suite;
 }
}

function afficheRangTable($label,$nomfor,$typechamp,$taille,$options,$ro,$presentation) {
 // si $typechamp est text ou absent, génére un input type=text
 //  si $option commence par Erreur ! affiche en rouge
 //  si $option commence par Attention ! affiche en bleu
 //  si option autre affiche en vert
 // si $typechamp est select, génére un select option
 // si $typechamp est datalist, génére un datalist
 // si typechamp est checkbox, génère une case à cocher
 // si typechamp est area, génère une zone texte
 // si typechamp est password, génère un champ passe (non visible)
 // si typechamp est number, génère un champ numérique avec boutons +, -
 // si typechamp est lien, génère un lien
 // si $typechamp est ... à développer
 // $nomfor devient le name et le for/id
 // $label est le texte du label du champ
 // $options est un tableau des options possibles pour un select ou la valeur par défaut si text
 // $ro = Readonly, ou non renseigné Champ à saisir --OK--
 // $presentation vaut l pour générer label seul, d pour générer tag seul,
 // et vaut '' pour générer les deux et vaut nl pour aller à la ligne
 $style = "";
 if ($typechamp == 'submit') {
  echo '<td><input type="submit" name="'.$nomfor.'" value="'.$options.'" /></td>';
 }
 elseif ($typechamp == 'select') {
  if ($presentation == "l" OR $presentation == "")
   echo '<td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "") {
   echo '<td><select id="'.$nomfor.'" name="'.$nomfor.'" onchange="changeListe('.$nomfor.');" >';
//   echo '<td><select id="'.$nomfor.'" name="'.$nomfor.'" onclick="selrefref('.$nomfor.');"  onchange="changeListe('.$nomfor.');" >';
   for ($i=0;$i<count($options);$i++) {
    $value = $options[$i][0];
    $valeur = $options[$i][1];
    $selected = ''; 
    if (isset($options[0][2]) AND $options[$i][0] == $options[0][2]) 
     $selected='selected';
    echo '<option value="'.$value.'" '.$selected.'  >'.$valeur.'</option>';	
   }
   echo '</select></td>';
  }
 }
 elseif ($typechamp == 'datalist') {
  $value = "";
  if (isset($options[0][2])) $value = $options[0][2];
  if ($presentation == "l" OR $presentation == "")
   echo '<td><label for="id'.$nomfor.'" >'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "") {
   echo '<td><input list="ma'.$nomfor.'" type="text" size="'.$taille.'" id="id'.$nomfor.'" name="'.$nomfor.'" autocomplete="off" onchange="changeListe('.$nomfor.');" value="'.$value.'" />';
   echo '<datalist id="ma'.$nomfor.'"  >'; 
   for ($i=0;$i<count($options);$i++) {
    $valeur = $options[$i][1];
    echo '<option value="'.$valeur.'" >'.$valeur.'</option>';	
   } 
   echo '</datalist></td>';
  }
 }
 elseif ($typechamp == 'checkbox') {
  if ($presentation == "l" OR $presentation == "")
   echo '<tr><td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "")
   echo '<td><input id="'.$nomfor.'" name="'.$nomfor.'" type="checkbox" value="'.$options.'"/></td></tr>';	
 }
 elseif ($typechamp == 'area') {
  if ($presentation == "l" OR $presentation == "")
   echo '<td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "")
   echo '<td><textarea name="'.$nomfor.'" id="'.$nomfor.'" rows="'.$taille.'" cols="80" '.$ro.'>'.$options.'</textarea></td>';	
 }
 elseif ($typechamp == 'password') {
  if ($presentation == "l" OR $presentation == "")
   echo '<tr><td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "")
   echo '<td><input style="'.$style.'" id="'.$nomfor.'" name="'.$nomfor.'" type="password" size ="'.$taille.'" '.$ro.'/></td></tr<';
 }
/* 
 elseif ($typechamp == 'number') {
  if ($presentation == "l" OR $presentation == "")
   echo '<tr><td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "")
   echo '<td><input id="'.$nomfor.'" name="'.$nomfor.'" type="number" value="'.$options.'"/></td></tr>';	
 }
*/
 elseif ($typechamp == 'date') { /// modif 09/08/2023
  if ($presentation == "l" OR $presentation == "")
   echo '<td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "" OR $presentation == "nl")
   echo '<td><input id="'.$nomfor.'" name="'.$nomfor.'" type="date" size ="'.$taille.'" value="'.$options.'" '.$ro.'/></td>';   
 }
 elseif ($typechamp == 'number') { /// ajout 09/08/2023, modif 16/12/2023 text cadré à droite
  if ($presentation == "l" OR $presentation == "")
   echo '<td><label for="'.$nomfor.'">'.$label.'</label></td>';
  if ($presentation == "d" OR $presentation == "" OR $presentation == "nl")
   echo '<td><input id="'.$nomfor.'" name="'.$nomfor.'" type="text" style="text-align:right;" size ="'.$taille.'" value="'.$options.'" '.$ro.'/></td>';   
 }
 elseif ($typechamp == 'lien') {
  echo '<td><a href="refref.php?id='.$options.'">'.$options.'</a></td>';
 }
 else {
// cas du champ text
  if (substr($options,0,8) == 'Erreur !') { // affiche message d'erreur en rouge
	$style = 'color:red;';
  }
  elseif (substr($options,0,11) == 'Attention !') { // affiche message d'alerte en bleu
	$style = 'color:blue;';
  }
  else {
   $style ='';
   if ($presentation == "l" OR $presentation == "")
    echo '<td><label for="'.$nomfor.'">'.$label.'</label></td>';
   if ($presentation == "d" OR $presentation == "")
    echo '<td><input style="'.$style.'" id="'.$nomfor.'" name="'.$nomfor.'" type="texte" size ="'.$taille.'" value="'.$options.'" '.$ro.'/></td>';
  }
//   echo '<td><input style="'.$style.'" id="'.$nomfor.'" name="'.$nomfor.'" type="text" size ="'.$taille.'" value="'.$options.'" '.$ro.' onchange="changeText('.$nomfor.');"/></td>';
   
  if ($presentation == "nl")
   echo '</tr><tr>';
 }
}

function initialiseTypes() {
/* initialisation de tous types de données utilisés 
 utilisé par s1objet et r1objet
*/
 $initialisation = array();
 $initialisation[0][0] = "texte";
 $initialisation[0][1] = "texte";
 $initialisation[1][0] = "fichier";
 $initialisation[1][1] = "fichier";
 $initialisation[2][0] = "date";
 $initialisation[2][1] = "date";
 $initialisation[3][0] = "number";
 $initialisation[3][1] = "number";
 $initialisation[4][0] = "datalist";
 $initialisation[4][1] = "datalist";
 return $initialisation;
}

function initialisePileG($bdd,$ficheg,$repetg) {
/* à partir de la donnée de la fiche générique initiale, recherche dans relation la cascade des données/fiches associées
 Utilisé pour construire le formulaire de saisie des données d'une fiche
*/
 global $pileg,$ctr;
 if (!isset($ctr)) 
  $ctr = 0;
 for ($rg=0;$rg<$repetg;$rg++) { 
  array_push($pileg,$ficheg);
  $composants = selectComposant($bdd,$ficheg);	// lit composants de la fiche (composé)
  $nbc = count($composants);
  for ($c=0;$c<$nbc;$c++) {			// pour chaque composant
   $idc = intval($composants[$c][0]);		// lit son Id
   $repet = intval($composants[$c][1]);		// et son facteur de répétition prévu
   $donneestype = selectIdType($bdd,$idc);
   $type = $donneestype[4];			// lit son type
   $ctr++;					// sécurité anti boucle
   if ($ctr > 100)
    break;
   if ($type == "fiche") { 
    initialisePileG($bdd,$idc,$repet);		// itère la génération
   }
   else {
    for ($r=0;$r<$repet;$r++) {
     array_push($pileg,$idc);
    }
   }
  }
 }
 return($pileg);
}

function initialisePileO($bdd,$pileo,$pilep,$fiche,$mode) {
/* à partir de la donnée de la fiche initiale, recherche dans relation la cascade des données/fiches associées
 Utilisé pour garnir les champs d'une fiche courante
*/
 global $pileo,$pilep,$ctr;
 if (!isset($ctr)) 
  $ctr = 0;
 $composants = selectComposant($bdd,$fiche);
 $nbc = count($composants);
 for ($c=0;$c<$nbc;$c++) {
  $idc = intval($composants[$c][0]); 
  $donnees = selectId($bdd,$idc);
  $idpere = $donnees[1];
  $donneestype = selectIdType($bdd,$idpere);
  $type = $donneestype[4];
  if ($mode == 0) {	// supprimé OR mode == 3 non utilisé
   $repet = intval($composants[$c][1]);
   for ($r=0;$r<$repet;$r++) {
    array_push($pileo,$idc);
    array_push($pilep,$idpere);
   }
  }
  else {
   array_push($pileo,$idc);
   array_push($pilep,$idpere);
  }
  if ($type == "fiche") { 
   $ctr++;
   if ($ctr > 100)
    break;
   else {
    initialisePileO($bdd,$pileo,$pilep,$idc,$mode);
   }
  }
 }
}

function initialisePileS($bdd,$pileos,$fiche,$mode) {
/* à partir de la donnée de la fiche en cours de saisie recherche dans relation la cascade des données/fiches associées
 Utilisé pour la recherche de doublons
*/
 global $pileos,$ctr;
 if (!isset($ctr)) 
  $ctr = 0;
 $composants = selectComposant($bdd,$fiche);
 $nbc = count($composants);
 for ($c=0;$c<$nbc;$c++) {
  $idc = intval($composants[$c][0]); 
  $donnees = selectId($bdd,$idc);
  $idpere = $donnees[1];
  $donneestype = selectIdType($bdd,$idpere);
  $type = $donneestype[4];
  if ($mode == 0 OR $mode == 3) {
   $repet = intval($composants[$c][1]);
   for ($r=0;$r<$repet;$r++) {
    array_push($pileos,$idc);
   }
  }
  else {
   array_push($pileos,$idc);
  }
  if ($type == "fiche") { 
   $ctr++;
   if ($ctr > 100)
    break;
   else {
    initialisePileS($bdd,$pileos,$idc,$mode);
   }
  }
 }
}
function afficheForme($bdd,$idpere,$mode,$idfiche) {
/* Utilisation de la pileg qui contient la liste des IdPere de tous les champs à afficher
Si mode = 0 (recherche) supprime les répétitions de la pileg et garde les valeurs des champs (critères)
Si mode = 1 (saisie) laisse les champs à blanc
Si mode = 2 (affichage) utilise les pileo et pilep pour charger les valeurs des champs
en caché affiche les IdPere  (idperenn) et affiche en visible les champs à saisir ou renseignés (textenn)  
*** modif en cours ajout du bouton Sélection fiche existante qui modifie le $_POST des progs utilisateurs !
*/
 global $pileg,$pilep,$pileo,$IdRacFic;
 $pileg = array();
 $pileg = initialisePileG($bdd,$idpere,1);
 $debut = array_shift($pileg); 
 if ($mode == 0) {			// pas de champs doublons affichés en guide de recherche
  $pileg = array_unique($pileg);
  $pileg = array_values($pileg);
 }
 $nbpileg = count($pileg);
 if ($mode ==2) {			// si mode modification, 
  $pileo = array();			// initialise et charge pileo et pilep (piles paralléles)
  $pilep = array();
  initialisePileO($bdd,$pileo,$pilep,$idfiche,$mode);// pile des occ. et pile parallèle des pères
  $pmax = count($pilep);
 }
 $nf = 0;				// numérotation d'affichage des sous fiches
 for ($c=0;$c<$nbpileg;$c++) {		// pour tous les pileg[] affichables
  $io = $pileg[$c];			// Id de la fiche père ou générique
  if ($c > 0)
   $iop = $pileg[$c-1];			// récup Id précédent 	
  if ($c < $nbpileg-1)
   $ios = $pileg[$c+1];			// récup Id suivant 
  print'<input type="hidden" name="idpere'.$c.'" value="'.$io.'" />';// passer id du père de l'occ. objet/fiche
  $donnees = selectId($bdd,$io);	// accède à l'objet générique
  $label = $donnees[3].' '; 		// lit label du champ
  $visible = $donnees[2];		// lit visibilité ou non (utilisé en recherche) 
  $donneestype = selectIdType($bdd,$io); // accède à l'objet_type générique
  $taille = $donneestype[3];		// lit taille du champ
  $type = $donneestype[4];		// lit type du champ 
  $valeur = "";
  if ($mode == 2 ) {
// charger valeur du champ et rechercher le rang de pilep(rang) = pileg(c),
// si trouvé, valeur = pileo(rang) et masquer pilep(rang) utilisé
// borner la recherche de données à l'intérieur d'une fiche
   for ($p=0;$p<$pmax;$p++) {
    if ($pilep[$p] == $pileg[$c]) {
     $reponses = selectNom($bdd,$pileo[$p]);
     $valeur = $reponses[0];
     $pilep[$p] = 0; // masqué déjà utilisé
     break;
    } 
 // évite décalage des lignes adresses si plusieurs fiches adresse    
    $idx = selectIdPere($bdd,$pilep[$p]);	// est ce une fiche ?
    if ($idx == $IdRacFic) {
     break;	// borner la recherche dans une fiche
    } 
   }
  }
  if ($type == "fiche") {		// traitement fiche
   $nf++;
   if ($mode == 2) {			// si mode affichage avant modification 
    echo '<tr>';
    afficheRangTable(' ','ficheexist','submit','10','Sélection '.$label.' existante','','l');
    echo '</tr>';   
    $_SESSION['idfichepere'] = $io;
    echo '<tr>';
    afficheRangTable($label.' ('.$nf.')','texte'.$c,'text','50',$valeur,'',''); 
    echo '</tr>';
   }
   elseif ($mode == 1)  {	// présentation = 'ld' ou '' pour générer le texte associé
    echo '<tr>';
    afficheRangTable($label.' ('.$nf.')','texte'.$c,'text','50','##','','');
    echo '</tr>';
   }
   else {
    echo '<tr>';
    afficheRangTable($label,'texte'.$c,'text','30',$valeur,'','l');	// remplacé '' par $valeur
    echo '</tr>';
   }
  }  
  else {				// traitement données
   if ($io == $iop)			// si même IdPere
    $label = ' '; 			// ne réaffiche pas le label
   echo '<tr>'; 
   if ($mode == 0) {			// recharger les critères de recherche positionnés si besoin
    if (isset($_POST['texte'.$c]))
     $valeur = $_POST['texte'.$c];
    else
     $valeur = '';
   }
   afficheRangTable($label,'texte'.$c,'text',$taille,$valeur,'','');
   echo '</tr>';
 }
}
}
// fonction d'ouverture de la base de données biblio;
// Utilisé par tous 
function ouvreBase() {
 // retourne l'objet $bdd instanciation de la classe PDO
 $bdd = "";
 global $param2,$param3,$base;
 $host = "localhost";		// serveur
 $param2 = "admin";		// user base
 $param3 = "passe";		// password base
 $options = " --opt --single-transaction --skip-lock-tables ";
 $base = "objet";		// nom base ***
 try {
  $param1="mysql:host=".$host.";dbname=".$base.";charset=utf8mb4";
  $bdd = new PDO($param1,$param2,$param3); 
  $bdd->exec('SET NAMES utf8');
// fixer attribut PDO
  $bdd->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION); // gestion erreurs par défaut en php8
//  $bdd->setAttribute(PDO::ATTR_CASE, PDO::CASE_NATURAL);  // inopérant
//  $bdd->setAttribute(PDO::MYSQL_ATTR_INIT_COMMAND, "SET NAMES utf8"); // marche ???

/* lire attributs PDO 
  $attributes = array(
"AUTOCOMMIT", "ERRMODE", "CASE", "CLIENT_VERSION", "CONNECTION_STATUS",
"ORACLE_NULLS", "PERSISTENT",  "SERVER_INFO", "SERVER_VERSION", "DRIVER_NAME", 
);
// enlevé "PREFETCH","TIMEOUT"  ,"MYSQL_ATTR_INIT_COMMAND" "MYSQL_ATTR_USE_BUFFERED_QUERY"
foreach ($attributes as $val) {
   echo "<br>PDO::ATTR_$val: ";
   echo $bdd->getAttribute(constant("PDO::ATTR_$val")) . "\n";
}
*/  
  return $bdd;
 }
 catch (Exception $e) {
  die('Erreur fatale:'.$e->getMessage()); }
}

// retourne les Id des racines, soit l'IdPere des objets ou de relations
// on distingue les objets des fiches génériques car les fiches n'ont pas de caractéristiques dans objet_type et
// ça permet de séparer la recherche des objets de la recherche des fiches
// ??? la séparation stricte entre objets et fiches peut elle géner la récursion de fiches ???
function initBase($bdd) {
 global $IdRacGen,$IdRacObj,$IdRacFic,$IdRacRel,$libracgen,$libracobj,$libracfic,$libracrel,$maxselect,$maxlus,$lgnomfiche,$nbcolmax;
 initConstantes();
 $IdRacGen = selectTexte($bdd,$libracgen,-1);
 $IdRacObj = selectTexte($bdd,$libracobj,-1);
 $IdRacFic = selectTexte($bdd,$libracfic,-1);
 $IdRacRel = selectTexte($bdd,$libracrel,-1);
 $maxselect = 12; // nombre maxi de sélections proposées sur m1fiche et ...
 $maxlus = 1000; // limite du nombre de lignes affichées pour une table
 $lgnomfiche = 50; // nombre maxi de caractères d'un nom de fiche
 $nbcolmax = 10; // nombre de réponses par ligne pour la recherche (r2fiche)
}

// Réunion de toutes constantes de l'application dans cette fonction
// Utilisé par init.php et par initBase(); garder ici, dans lib
function initConstantes() {
 global $libracgen,$libracobj,$libracfic,$libracrel;
 $libracgen = "__Racine générale__";
 $libracobj = "__Racine de tous objets génériques__";
 $libracfic = "__Racine de toutes les fiches génériques__";
 $libracrel = "__Racine de toutes relations__";
}

//fonction retournant la liste des tables de la base dans $options[][0]
// 	---> pour un select, il faut générer le $options[][1] = $options[][1]
// $select est TRUE ou FALSE
// Utilisé par edittable.php et liretable.php
function listeTables($bdd,$select) {
 $reponse = $bdd->query("show tables ;") or die(print_r($bdd->errorInfo()));
 $i=0;
 while ($donnees = $reponse->fetch())  {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 if ($select) {
  $nbtable = count($options);
  for ($t=0;$t<$nbtable;$t++) {
   $options[$t][1] = $options[$t][0];	// créer le libellé pour select
  }	
 }
 return $options;
}

// fonction de lecture intégrale d'une table de la base de données
// $table contient le nom de la table à lire
// la fonction retourne un tableau des lignes de la table
// Utilisé par liretable.php seulement.
function lireTable($bdd,$table) {
// retourne un tableau doublement indicé (ligne, champ)
 $options = array();
 $donnees = array();
 $reponse = $bdd->query("SELECT * FROM ".$table." ;") or die(print_r($bdd->errorInfo()));
 $i=0;
 while ($donnees = $reponse->fetch())  {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 return $options;
}

// fonction retournant tous les champs d'un objet d'Id donné
// Utilisé par presque tous
function selectId($bdd,$id) {
 $donnees = array();
 $reponse = $bdd->query("SELECT * FROM objet WHERE Id =".$id." ;") 
 or die('selectId:'.$libel.'/'.$idpere.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 return $donnees;
}

// fonction retournant tous les champs d'un objet d'IdPere et d'Id donné
// Utilisé par gestionorphelins
function selectIdPereId($bdd,$idpere,$id) {
 $donnees = array();
 $reponse = $bdd->query("SELECT * FROM objet WHERE IdPere = ".$idpere." AND Id =".$id." ;") 
 or die('selectIdPereId:'.$idpere.'/'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
//  $reponse->closecursor();
 return $donnees;
}

// fonction retournant les caractéristiques d'un objet d'Id donné
// Utilisé par s1fiche.php et a1fiche.php et s2objet.php
function selectIdType($bdd,$id) {
 $donnees = array();
 $reponse = $bdd->query("SELECT * FROM objet_type WHERE Id = ".$id." ;")  
 or die('selectIdType:'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
  return $donnees;
}

// fonction de recherche dans table objet pour Id donné 
// retourne un et un seul IdPere
// Utilisé par a1fiche.php
function selectIdPere($bdd,$id) {
 $donnees = array();
 $reponse = $bdd->query("SELECT IdPere FROM objet WHERE objet.Id = ".$id." ;") 
 or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 return $donnees[0];	
}

// fonction de recherche dans table objet pour un Texte réputé unique et visible ou non
// retourne un et un seul Id
// utilisé par initBase, m2fiche
function selectTexte($bdd,$texte,$visible) {
 $donnees = array();
 $reponse = $bdd->query("SELECT Id FROM objet WHERE Texte = '".$texte."' AND visible = ".$visible." ;") 
 or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 return $donnees[0];
}

// fonction retrouvant toutes les occurrences d'un objet/fiche générique
function selectOccFils($bdd,$idpere) {
 $donnees = array(); $options = array();
 $reponse = $bdd->query("SELECT Id FROM objet WHERE IdPere = ".$idpere." ;") 
 or die('selectOccFils:'.$idpere.' '.print_r($bdd->errorInfo()));
 $i=0;
 while ($donnees = $reponse->fetch())  {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 return $options;
}

// recherche nom et IdPere d'un objet identifié par son id (utilisé par r2fiche et r2objet
function selectNom($bdd,$id) {
 $reponse = $bdd->query("SELECT Texte, IdPere FROM objet WHERE Id = ".$id." ;") 
 or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 return $donnees;
}

// recherche si un objet ou fiche générique a des enfants visibles utilisé par m1fiche
function existeObjetFils($bdd,$idpere,$visible) {
 if (!isset($visible)) $visible = 0;
 $donnees = array();
 $reponse = $bdd->query("SELECT Id FROM objet WHERE IdPere = ".$idpere."  AND visible = ".$visible." ;") 
 or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 if ($donnees == "")
  return FALSE;	// pas de fils
 else
  return TRUE;	// existe au moins un fils
}

// recherche existence dans table objet d'un objet/fiche générique
// donné par son idpere, son texte; visible = 0
// retourne un et un seul Id ou 0 si rien trouvé 
// Utilisé par c1objet.php, c1fiche.php
function existObjetInvisible($bdd,$idpere,$texte) {
 $donnees = array();
 $reponse = $bdd->query("SELECT Id from objet where IdPere = '".$idpere."' and Texte = '".$texte."' and visible = 0 ;") 
 or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 if ($donnees != "")
  return $donnees[0];
 else
  return 0;
}

// fonction de verif existence utilisateur
function selectUsager($bdd,$email) {
 $donnees = array();
 $reponse = $bdd->query("SELECT * FROM usager WHERE email = '".$email."';") or die(print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 if (isset($donnees))
  return $donnees;
 else
  return 0;
}

// function de création nouvel utilisateur
function insertUsager($bdd,$nom,$prenom,$email,$passe,$profil) {
 $id = -1;
 $req = $bdd->prepare( ' INSERT INTO usager (passe,nom,prenom,profil,email)  
  VALUES (:passe,:nom,:prenom,:profil,:email ) ' ) or die(print_r($bdd->errorInfo()) );
 $req->execute(array(':passe' => $passe,':nom' => $nom,':prenom' => $prenom,':profil' => $profil,':email' => $email )) 
  or die(var_dump($bdd->errorInfo()));  
 $id = $bdd->lastinsertid();
 return $id;
}

/* Fonction créant un nouvel objet ou fiche générique ou occurrence et
 contrôlant qu'il n'a pas déjà été créé avec IdPere et Texte identiques
 retourne l'Id de l'objet/fiche existant ou de l'objet/fiche créé
 Utilisé par presque tous
*/
function insertObjet($bdd,$idpere,$texte,$visible) {
// remplacer ' par '' pour éviter erreur sql
$sep = "'";
$mots = explode($sep,$texte);
$sep ="''";
$texte = implode($sep,$mots);
// vérification unicité sur IdPere et Texte (sans tenir compte de la visibilité)
 $donnees = array();
 $reponse = $bdd->query("SELECT Id from objet WHERE Texte ='".$texte."' AND IdPere ='".$idpere."' ;") 
 or die('selectObjet:'.$texte.'/'.$idpere.' '.print_r($bdd->errorInfo()));
 $donnees = $reponse->fetch();
 if ($donnees == NULL OR $donnees == "") {	// crée nouvel objet/fiche et fixe visibilité			      
  $req = $bdd->prepare( ' INSERT INTO objet (IdPere,visible,Texte) 
  VALUES (:idpere,:visible,:texte ) ' ) or die(print_r($bdd->errorInfo()) );
  $req->execute(array(':idpere' => $idpere,':visible' => $visible,':texte' => $texte )) 
  or die(var_dump($bdd->errorInfo()));  	
  $idocc = $bdd->lastinsertid();		// note Id de l'objet créé
 }
 else {
  $idocc = $donnees[0];				// note id de l'objet existant déjà
 }
 return $idocc;	
}

/* fonction de création d'une occurrence objet_type
   Crée une occurrence objet_type
   Utilisé par c1objet.php
*/
function insertObjetType($bdd,$id,$umin,$umax,$size,$type) {
 $req = $bdd->prepare( ' INSERT INTO objet_type (Id,unicite_min,unicite_max,taille,type) 
 VALUES (:id,:umin,:umax,:size,:type ) ' ) or die(print_r($bdd->errorInfo()) );
 $req->execute(array(':id' => $id,':umin' => $umin,':umax' => $umax,':size' => $size,':type' => $type )) 
 or die(var_dump($bdd->errorInfo()));  	
}

/* recherche des fiches ou objets dont l'idpere et la visibilité sont donnés
 si visible = 0 retourne des objets ou fiches génériques ou des occ. fiche
 si visible = 1 retourne des occurrences d'objets uniquement
 retourne une liste de couples (Id,Texte)
 Utilisé par presque tous, respecte la casse
*/
function selectObjet($bdd,$idpere,$texte,$visible) {
 $donnees = array();
 $options = array();
 if ($idpere == "") {
  $reponse = $bdd->query("SELECT Id,Texte,IdPere FROM objet WHERE Texte LIKE '".$texte."' AND visible = ".$visible." ;") 
  or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 }
 else {
  $reponse = $bdd->query("SELECT Id,Texte,IdPere from objet WHERE IdPere = '".$idpere."' 
  AND Texte LIKE '".$texte."' AND visible = ".$visible." ;") 
  or die('selectIdPere:'.$id.' '.print_r($bdd->errorInfo()));
 }
 $i=0;
 while ($donnees = $reponse->fetch()) {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 return $options;
}

/* recherche des fiches ou objets dont l'idpere et la visibilité sont donnés
 si visible = 0 retourne des objets ou fiches génériques ou des occ. fiche
 si visible = 1 retourne des occurrences d'objets uniquement
 retourne une liste de couples (Id,Texte)
 Utilisé par presque tous, ne respecte ni la casse, ni les accents 
 SELECT * FROM objet WHERE Texte LIKE 'roze' COLLATE utf8mb4_general_ci ;	ok sous mysql
 *** ne marche pas avec PDO! 
 https://stackoverflow.com/questions/67131669/illegal-mix-of-collations-error-with-stock-install-of-phpmyadmin
*/
function selectObjetci($bdd,$idpere,$texte,$visible) {
//print_r(PDO::getAvailableDrivers());
//$bdd->setAttribute(PDO::ATTR_EMULATE_PREPARES,false);
//$bdd->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_WARNING);
 $collate = "COLLATE utf8mb3_general_ci";	// ne marche pas avec utf8mb4 !!
 $donnees = array();
 $options = array();
 if ($idpere == "") {
  $reponse = $bdd->query("SELECT Id,Texte,IdPere FROM objet WHERE Texte LIKE '".$texte."' ".$collate." AND visible = ".$visible." ;") 
  or die('selectIdPere:'.$idpere.' '.print_r($bdd->errorInfo()));
 }
 else {
  $reponse = $bdd->query("SELECT Id, Texte, IdPere from objet WHERE IdPere =".$idpere." AND visible =".$visible." AND Texte LIKE '".$texte."' ".$collate."  ;") or  die('selectIdPere:'.$idpere.' '.print_r($bdd->errorInfo()));
//  echo "PDO::errorInfo():<br>";
//  print_r($bdd->errorInfo());
 }
 $i=0;
 while ($donnees = $reponse->fetch()) {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 return $options;
}

// fonction de mise à jour du texte d'un objet
// utilisé par m1objet.php et r1objet.php
function updateObjet($bdd,$id,$texte) {
 $req = $bdd->prepare( '
 UPDATE  objet SET Texte = :texte WHERE objet.Id = :id' )
 or die(print_r($bdd->errorInfo()) );
 $req->execute(array(':texte'=>$texte,':id'=>$id )) 
 or die(var_dump($bdd->errorInfo()));	
}

// fonction de mise à jour des caractéristiques objet
// utilisé par r1objet.php
function updateObjetType($bdd,$id,$mini,$maxi,$size,$type) {
 $req = $bdd->prepare( '
 UPDATE  objet_type SET objet_type.unicite_min = :mini, objet_type.unicite_max = :maxi, objet_type.taille = :size, objet_type.type = :type WHERE objet_type.Id = :id ' )
 or die(print_r($bdd->errorInfo()) );
 $req->execute(array(':mini'=>$mini, ':maxi'=>$maxi, ':size'=>$size,':type'=>$type,':id' => $id )) 
 or die(var_dump($bdd->errorInfo()));	
}
// fonction de suppression d'un objet pour un Id donné
function deleteObjet($bdd,$id) {
 $req = $bdd->prepare( 'DELETE FROM objet 
 WHERE objet.Id = :id ' ) or die(print_r($bdd->errorInfo()));
 $req->execute(array(':id'=>$id)) or die(print_r($bdd->errorInfo()));		
}

// fonction de suppression d'un type d'objet et de ses caractéristique
function deleteObjetType($bdd,$id) {
 $req = $bdd->prepare( 'DELETE FROM objet 
 WHERE Id = :id ' ) or die(print_r($bdd->errorInfo()));
 $req->execute(array(':id'=>$id)) or die(print_r($bdd->errorInfo()));	
 $req = $bdd->prepare( 'DELETE FROM objet_type 
 WHERE Id = :id ' ) or die(print_r($bdd->errorInfo()));
 $req->execute(array(':id'=>$id)) or die(print_r($bdd->errorInfo()));		
}

// fonction de création occ. relation
// Utilisé par c2fiche.php, s1fiche.php, c1fiche.php, s2fiche et m1fiche.php
function insertRelation($bdd,$compose,$composant,$nombre) {
 $req = $bdd->prepare( ' INSERT INTO relation (IdCompose, IdComposant, IdNombre) 
 VALUES (:idse,:idsant,:idnombre ) ' ) or die(print_r($bdd->errorInfo()) );
 $req->execute(array('idse' => $compose,'idsant' => $composant,'idnombre' => $nombre)) 
  or die(var_dump($bdd->errorInfo()));  	
}

// fonction de remplacement de IdCompose
function updateCompose($bdd,$oldcompose,$newcompose) {
 $req = $bdd->prepare( ' UPDATE  relation SET relation.IdCompose = :newc WHERE relation.IdCompose = :oldc' ) or 
 die(print_r($bdd->errorInfo()) );
 $req->execute(array(':newc'=>$newcompose,':oldc'=>$oldcompose )) 
 or die(var_dump($bdd->errorInfo()));
}

// fonction de remplacement de IdComposant
function updateComposant($bdd,$oldcomposant,$newcomposant) {
 $req = $bdd->prepare( ' UPDATE  relation SET relation.IdComposant = :newc WHERE relation.IdComposant = :oldc' ) or 
 die(print_r($bdd->errorInfo()) );
 $req->execute(array(':newc'=>$newcomposant,':oldc'=>$oldcomposant )) 
 or die(var_dump($bdd->errorInfo()));
}

// fonction de suppression de relation pour Composé et Composant donnés
function deleteRelation($bdd,$compose,$composant) {
 if (isset($compose) AND isset($composant)) {
  echo '<br>isset compose et composant';
  $req = $bdd->prepare( 'DELETE FROM relation 
  WHERE IdCompose = :idcompose AND IdComposant = :idcomposant ' ) or die(print_r($bdd->errorInfo()));
  $req->execute(array(':idcompose'=>$compose,'idcomposant'=>$composant)) or die(print_r($bdd->errorInfo()));	
 }
 if (isset($compose) AND !isset($composant)) {
  echo '<br>!isset composant';
  $req = $bdd->prepare( 'DELETE FROM relation 
  WHERE IdCompose = :idcompose ' ) or die(print_r($bdd->errorInfo()));
  $req->execute(array(':idcompose'=>$compose)) or die(print_r($bdd->errorInfo()));	
 }
 if (!isset($compose) AND isset($composant)) {
  echo '<br>!isset compose';
  $req = $bdd->prepare( 'DELETE FROM relation 
  WHERE IdComposant = :idcomposant ' ) or die(print_r($bdd->errorInfo()));
  $req->execute(array('idcomposant'=>$composant)) or die(print_r($bdd->errorInfo()));	
 }
}

// fonction de suppression de relation pour Composé donné
// Utilisé par c2fiche.php et m1fiche.php
function deleteComposant($bdd,$compose) {
 $req = $bdd->prepare( 'DELETE FROM relation 
 WHERE IdCompose = :idcompose ' ) or die(print_r($bdd->errorInfo()));
 $req->execute(array(':idcompose'=>$compose)) or die(print_r($bdd->errorInfo()));	
}

// fonction de recherche des occ relation  pour IdComposant donné
// retourne tableau des IdComposé(s)
// Utilisé par A1objet.php et a1fiche.php et r2fiche.php m2objet.php
function selectCompose($bdd,$idcomposant) {
 $options = array();
 if ($idcomposant != NULL) {
  $reponse = $bdd->query("SELECT IdCompose FROM relation 
  WHERE  IdComposant = ".$idcomposant." ;") 
  or die('selectCompose:'.$idcomposant.' '.print_r($bdd->errorInfo()));
  $i=0;
  while ($donnees = $reponse->fetch()) {
   $options[$i] = $donnees;
   $i++;
  }	
  $reponse->closecursor();
 }
 return $options;	 	
}
// fonction de recherche des occ relation pour IdComposé donné
// retourne tableau des IdComposant(s)
// Utilisé par c2fiche.php m1fiche et a1fiche.php et s2fiche r2fiche
function selectComposant($bdd,$idcompose) {
 $composants = array();
 $donnees = array();
 if ($idcompose != NULL) {
  $reponse = $bdd->query("SELECT IdComposant,IdNombre FROM relation WHERE IdCompose = ".$idcompose." ;")
  or die('selectComposant:'.$idcompose.' '.print_r($bdd->errorInfo()));
  $ic=0;
  while ($donnees = $reponse->fetch())  {
   $composants[$ic] = $donnees;
   $ic++;
  }	
  $reponse->closecursor();
 }
 return $composants;	 	
}

// fonction de recherche d'occ relation pour composé et composant donnés
function selectRelation($bdd,$compose,$composant) {
 if ($compose != NULL AND $composant != NULL) {
  $reponse = $bdd->query("SELECT IdNombre FROM relation 
  WHERE IdCompose = ".$compose." AND IdComposant =".$composant." ;") 
  or die('selectRelation:'.$compose.'/'.$composant.' '.print_r($bdd->errorInfo()));	
  $donnees = $reponse->fetch();	
  return $donnees[0];	 // récupère IdNombre de la relation trouvée
 }
 else {
  return -1;		// si non trouvé retourne code erreur
 }
}

/* Pour chaque critère renseigné, recherche les objets correspondants et remonte aux fiches concernées.
 Tient compte ou non de la casse. Retourne les Id de ces fiches.
 Pour chaque Id de fiche retourné, vérifie que IdPere de celle-ci est égal au Id de référence (ex fiche générique Adresse ou Contact); 
 Sinon remonte à la fiche amont dans relation.
 ** suppose qu'il n'y a pas de fiche de fiche de fiche ... 2 niveaux max.
 * extension recherche du 22/10/2024
 but: pouvoir faire une recherche de type LIKE (par défaut) ou de type fourchette (>5 AND <=7 par exemple)
 Le type nombre du champ Texte peut en décider; faire alors une recherche du type de la donnée
 si ce type est nombre, fourchette, si ce type est autre like
 *** ne supporte pas les décimales (conversion Texte en nombre à effectuer !)
*/
function selectFiches($bdd,$Idficheref,$critere,$casse,$ecartdeg) {
 $fiches = array();
 if ($casse) $collate = "COLLATE utf8mb3_general_ci";
 else $collate = "";
 $datatype = $bdd->query("SELECT type FROM objet_type WHERE Id = ".$Idficheref." ; ") or die ('selectFiches: datatype'.print_r($bdd->errorInfo()));
 $donnee = $datatype->fetch();
 if ($ecartdeg == 0) { // si l'écart géodésique est inutilisé
 $reponse = $bdd->query("SELECT IdCompose FROM relation INNER JOIN objet ON objet.Id = relation.IdComposant WHERE objet.Texte LIKE '".$critere."' ".$collate." AND IdPere = ".$Idficheref." AND visible = 1 ;") or die ('selectFiches: '.$Idficheref.' '.$critere.' 
 '.$casse.' '.print_r($bdd->errorInfo()));
 } 
 else {	// si écart latitude/longitude spécifié
   $crit = array();
   $critmin = floatval($critere)-$ecartdeg;
echo '<br>Entre '.$critmin;
   $critmax = floatval($critere)+$ecartdeg;
echo ' et '.$critmax;
   $reponse = $bdd->query("SELECT IdCompose FROM relation INNER JOIN objet ON objet.Id = relation.IdComposant WHERE Texte  > ".$critmin." AND Texte < ".$critmax." ".$collate." AND IdPere = ".$Idficheref." AND visible = 1 ;") or die ('selectFiches: '.$Idficheref.' '.$critere.' 
 '.$casse.' '.print_r($bdd->errorInfo()));
 }
 
 $j = 0; 
 while ($donnees = $reponse->fetch())  {
   $fiches[$j] = $donnees[0];
   $j++;
 }	 
 $reponse->closecursor(); 
 return $fiches;
}
/* fonction déterminant le nombre de champs utilisés/référencés par une fiche (ou sous fiche)
 pour chaque champ de la sous fiche, retrouver son facteur de répétitiion (unicite_max) dans objet_type
 calculer somme des facteurs de répétition
*/
function nombreChamps($bdd,$idcompose) {
 $nombre = 0;
 $composants = selectComposant($bdd,$idcompose);
 $nbch = count($composants);
 for ($ch=0;$ch<$nbch;$ch++) {
  $reponses = $bdd->query("SELECT unicite_max FROM objet_type WHERE Id = ".$composants[$ch][0]." ;");
  $donnees = $reponses->fetch();
 // $reponses->closecursor();
  $nombre = $nombre + $donnees[0];
 }
 return $nombre;
}
// fonction générique de lecture de table pour ordre sql donné
// retourne un tableau des réponses
function selectTable($bdd,$sql) {
 $donnees = array();
 $options = array();
 $reponse = $bdd->query($sql) or die(print_r($bdd->errorInfo()));
 $i=0;
 while ($donnees = $reponse->fetch())  {
  $options[$i] = $donnees;
  $i++;
 }	
 $reponse->closecursor();
 print_r($options);
 return $options;	
}

function ouvreTrace($nomfichier) {
 $fp = fopen($nomfichier,'w');	// ouvre le fichier en écriture
 return $fp;
}
function ecritTrace($fp,$contenu) {
 $contenu = '\n'.$contenu;
 fwrite($fp,$contenu);
}
function fermeTrace($fp) {
 fclose($fp);
}
?>
