<?php
/* But de ce programme: Modifier mot de passe 
   Profil: Tous
*/

include('lib/lib.php'); // inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); // ouvre la base de données biblio;
include('lib/ban-menu.php'); // affiche entête Html, bannière personnalisée et menu dynamique

// contrôle accès autorisé pour tous
autorise(array(0));

DEFINE ('m0loginAbandon','Tentative accès base a échoué ! Abandon (contacter admin)');
DEFINE ('m0loginErrAncien','Erreur! Mot de passe ancien erronné. Abandon');
DEFINE ('m0loginErrNouv','Erreur! Mots de passe nouveaux différents. Abandon');
DEFINE ('m0loginOK','Changement de mot de passe effectué !');
DEFINE ('m0loginTitre','<h4>Modifier mot de passe</h4>');
DEFINE ('m0loginPasseAnc','Ancien passe');
DEFINE ('m0loginPasseNouv','Nouveau passe');
DEFINE ('m0loginValider','Valider modification du mot de passe');

if (isset($_POST['passeneo']) AND isset($_POST['modifier'])) { // traite la création de notification
 $poubelle = array_pop($_POST); // éliminer le post du bouton message (en trop pour la requête SQL
// print_r($_POST);
 $idMembre = $_SESSION['id']; // récupère id du membre/rédacteur/administrateur
 // récupère ancien mot de passe
 $sql="SELECT passe FROM usager WHERE id = $idMembre ;";
 $ids = selectTable($bdd,$sql);
 if (count($ids) != 1)
   die(m0loginAbandon);
 else {
 // compare avec le mot de passe ancien fourni
  $passeanc = $ids[0][0];
  if ($passeanc != md5($_POST['passeanc']))
    $_POST['message'] = m0loginErrAncien;
  else {
 // vérifie que les deux nouveaux passes sont identiques
   if ($_POST['passeneo'] != $_POST['passeneo1'])
    $_POST['message'] = m0loginErrNouv;
   else {  
 // enregistre le nouveau passe
    $passe = md5($_POST['passeneo']);
 $req = $bdd->prepare( '
	UPDATE  usager SET passe = :password WHERE id = :id' )
  	or die(print_r($bdd->errorInfo()) );
 $req->execute(array(':password'=>$passe,':id'=>$idMembre )) 
 or die(var_dump($bdd->errorInfo()));
 	// informe l'utilisateur
	 $_POST['message'] = m0loginOK;
   }
  }
 }
}

// affiche ou réaffiche le formulaire
?>
 <form method="POST" action="m0login.php">
<?php
 echo m0loginTitre;
 // affiche formulaire
 afficheChamp(m0loginPasseAnc,'passeanc','password','30','','',''); 
 afficheChamp(m0loginPasseNouv,'passeneo','password','30','','',''); 
 afficheChamp(m0loginPasseNouv,'passeneo1','password','30','','','');
 if (isset($_POST['message'])) 
  afficheChamp('','message','text','90',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','90','','','Readonly');
 $valider = m0loginValider;
 echo '<hr><input type="submit" name="modifier" value="'.$valider.'" />';
?>
<script>
 document.getElementById('passeanc').focus();
</script>
<?php
 echo '</form>';

include('lib/pied.php'); /* affiche pied de page */

?>
