<?php
/* But de ce programme: Lire toute table de la base
   Profil: Administrateur
*/
// affiche entête Html, bannière personnalisée et menu dynamique
include('lib/ban-menu.php'); 
// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
include('lib/lib.php');
// ouvre la base
$bdd = ouvreBase();
// contrôle accès autorisé par le profil Aministrateur seul
autorise(array(9));
initbase($bdd);

if (isset($_POST['nomtable'])) {
// affiche le nom des champs (et autres caractéristiques) de la table
 $sql = "Show columns from ".$_POST['nomtable'].";";
 $nomChamps = selectTable($bdd,$sql);
 // affiche contenu de la table si elle existe
 $options = lireTable($bdd,$_POST['nomtable']);
 if ($options == "" OR count($options) == 0) {
  $lmax = 0;
  $_POST['message'] = 'Attention !  La table '.$_POST['nomtable'].' est vide';
 }
 else {
  $lmax = count($options);		// nombre de lignes de la table
  if ($lmax > $maxlus) {
   $lmax = $maxlus;			// limitation
   $_POST['message'] = 'Seules les '.$lmax.' premières lignes sont affichées';
  }
  else {
   $_POST['message'] = 'La table comporte '.$lmax.' lignes ';
  }
  $rmax = count($options[0])/2;		// nombre de colonnes
  echo '<h4>Affichage de la table '.$_POST['nomtable'].'</h4>';
  echo '<table border="1">';
  echo '<tr>';
  for ($r=0;$r<$rmax;$r++) {
   echo '<th>'.$nomChamps[$r][0].'</th>';
  }
  echo '</tr>';
  for ($l=0;$l<$lmax;$l++) {
	echo '<tr>';
	for ($r=0;$r<$rmax;$r++) {
		echo '<td>'.$options[$l][$r].'</td>';
	}
	echo '</tr>';
  }
  echo '<tr>';
  for ($r=0;$r<$rmax;$r++) {
   echo '<th>'.$nomChamps[$r][0].'</th>';
  }
  echo '</tr>';
  echo '</table><hr>';

 }
}
else {
 unset($_POST);
}
?>
 <form method="POST" action="r0table.php">
<?php
 // affiche ou ré-affiche le formulaire de saisie des données
 echo '<h4>Choix (autre) table</h4>';
 $tables = listeTables($bdd,'TRUE');
// print_r($tables);
 afficheChamp('Nom table','nomtable','select','3',$tables,' ','');
// afficheChamp('Nom table','nomtable','text','25',$_POST['nomtable'],' ','');
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 echo '<br /><input type="submit" value="Valider" />';
?>
<script>
 document.getElementById('nomtable').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
