<?php
// Erreurs, Anomalies, remarques
/* But de ce programme: Rechercher les types de fiche génériques
 *** enrichir avec possibilité de cliquer sur un élément pour descendre dans l'arborescence des objets
 Affiche un tableau des données trouvées 
 *** ajouter suppression 
 *** vérifier que changt libellé est différent de libellé existant
 *** enrichir visu avec sous fiches génériques ? mais ne modifier que la fiche origine
 */
if (!isset($_SESSION)) session_start(); 		// démarre la session
//error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING);		// invalide erreur NOTICE et WARNING
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 						// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé par les profils Aministrateur et Gestionnaire
autorise(array(5,9));
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

DEFINE ('r1ficheExiste','Erreur ! Type fiche : '.$_POST['texte'].' déjà utilisée; ne peut être supprimée');
DEFINE ('r1ficheSupprime','Type fiche : '.$_POST['texte'].' supprimée');
DEFINE ('r1ficheKO','Erreur ! Rien n\'a été modifié !');
DEFINE ('r1ficheTitre1','<h4>Sélection de fiche</h4>');
DEFINE ('r1ficheChoix','Choix fiche ');
DEFINE ('r1ficheAffiche1','<h4>Affichage de : ');
DEFINE ('r1ficheAffiche2','</h4>');
DEFINE ('r1ficheListe',"Liste des objets / sous fiche(s) référencés par cette fiche");
DEFINE ('r1ficheEntete','<th>Description(s) objet(s) / fiche(s) référencé(s)</th>');
DEFINE ('r1ficheValid','Valider choix');
DEFINE ('r1ficheModif','Modifier cette fiche');
DEFINE ('r1ficheSupp','Supprimer type fiche');

$suppression = FALSE;

// sous programme d'affichage du message de retour ou d'erreur
function afficheMessage() {
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
}

if (isset($_POST['choix']) ) {		// Choix d'un type d'objet effectué
 print_r($_POST);
 $_POST['message'] = "";
 $fiche = $_POST['fiche'];
 $_SESSION['fiche'] = $fiche;
 header("Location:"."r1fiche.php?fiche=$fiche"); // Relance avec Id de objet modèle
}

if (isset($_POST['supp']) AND  $_SESSION['fiche'] != NULL ) {
// print_r($_POST); echo '<br>id='.$_SESSION['objet'];
 try {
   $bdd->beginTransaction(); 			// ouvre une transaction
   $id = $_SESSION['fiche'];
// vérifier que ce type d'objet n'a pas encore été utilisé
   $options = selectOccFils($bdd,$id);
   if (count($options) > 0 OR $options == '') {
    $_POST['message'] = r1ficheExiste;
    $bdd->commit();
   }
   else {
    deleteObjet($bdd,$id);			// supprime aussi relations (delete cascading)
    deleteObjetType($bdd,$id);
    $bdd->commit();
    $suppression = TRUE;
    $_POST['message'] = r1ficheSupprime;
   }
 }
 catch(Exception $e) {
  $bdd->rollback();	// invalide la transaction
  $_POST['message'] = r1ficheKO;
 }
}

if (isset($_POST['valid']) AND isset($_POST['fiche']) ) {	
 $poubelle = array_pop($_POST); 		// éliminer le post du valid
 $poubelle = array_pop($_POST); 		// éliminer le post du message
 $fiche = $_POST['fiche'];
 header("Location:"."m1fiche.php?fiche=$fiche"); // Relance avec Id de fiche à modifier
} 


// affiche le formulaire de saisie des données
// -------------------------------------------
 echo '<form method="POST" action="r1fiche.php">';
 if (isset($_GET['fiche'])) {			// si n° de fiche fourni dans l'url
  $_SESSION['objet'] = $_GET['fiche'];		// id du type de fiche sélectionnée
  $donnees = selectId($bdd,$_SESSION['fiche']);	// récupération du nom du type de fiche
  $_SESSION['libfiche'] = $donnees[3];		// libellé du pere des fiches
  $_POST['fiche'] = $_GET['fiche'];		// n° fiche en post
 }
 if (count($_POST) == 0) {			// lancement initial du programme (sans n° de fiche)
  echo r1ficheTitre1;
  $tabl = selectObjet($bdd,$IdRacFic,'%',0); 		// recherche des fiches génériques 
  $imax = count($tabl);
  if ($imax > 0) {
   for ($i=0;$i<$imax;$i++) {				// construit table des options du sélect
    $options[$i][0] = $tabl[$i][0];
    $options[$i][1] = $tabl[$i][1];
   }
   echo '<table><tr>';
   afficheRangTable(r1ficheChoix,'fiche','select','80',$options,'','');	// affiche sélection d'un type de fiche
   echo '</tr></table><br>';
   afficheMessage(); //
   $valider = r1ficheValid;
   echo '<hr><input type="submit" name="choix" value="'.$valider.'" />';	// affiche bouton submit de choix
  }
 }
 else {
  echo r1ficheAffiche1.$_SESSION['libfiche'].r1ficheAffiche2;	// pour le type de fiche sélectionné
  if (isset($_SESSION['fiche'])) {
   $valeur = $_SESSION['fiche'].' ';
   $composants = selectComposant($bdd,$valeur);
   $nbcomposant = count($composants);
   $entete = r1ficheEntete;
   echo '<table border="1"><tr>'.$entete.'</tr>';
   for ($a=0;$a<$nbcomposant;$a++) {
    $id = $composants[$a][0];
    $donnees = selectId($bdd,$id);
    $nom = $donnees[3];
    echo '<tr><td>'.$nom.'</td></tr>';
   }
   echo '</table>';
   if (!$suppression)
    $_POST['message'] = r1ficheListe;			
  }
  if (!$suppression) {
   echo '<input type="hidden" name="fiche" value="'.$valeur.'" /><br>';
   afficheMessage();
   $modifier = r1ficheModif;
   $supprimer = r1ficheSupp;
   echo '<hr><input type="submit" name="valid" value="'.$modifier.'" />';	// affiche bouton submit de validation
   $options = selectOccFils($bdd,$_SESSION['fiche']);
   if (count($options) == 0 OR $options == '') {		// affiche possibilité de suppression si non utilisé
    echo ' <input type="submit" name="supp" value="'.$supprimer.'" />';
   }
  }
  else
   echo '<br>'; afficheMessage();
 } 
?>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
