<?php
// Erreurs, anomalies, remarques
// Dernière mise à jour: 26/04/2024
/* **** utiliser $data = htmlentities($_POST[]) pour protéger des attaques Html
Pas de solution implémentée */
/* Programme de recherche d'un type d'objet
 1. Sélection du type d'objet
 2. Modification valeur de cet objet voire suppression
 Les doublons type, valeur sont interdits
*** reste à faire: suppression avec contrôles
*** vérifier changt libellé objet différent de libellé objet existant
*/

session_start(); 			// démarre la session
include('lib/lib.php'); 		// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 			// ouvre la base de données ;
include('lib/ban-menu.php'); 		// affiche entête Html, bannière personnalisée et menu dynamique
autorise(array(5,9));			// contrôle accès autorisé pour admin et gestionnaire
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

DEFINE ('r1objetType','Erreur ! Le type ne peut être fiche !');
DEFINE ('r1objetOK','Caractéristiques de : '.$_POST['texte'].' modifiées');
DEFINE ('r1objetKO','Erreur ! Rien n\'a été modifié !');
DEFINE ('r1objetExiste','Erreur ! Type objet : '.$_POST['texte'].' déjà utilisé; ne peut être supprimé');
DEFINE ('r1objetSupprime','Type objet : '.$_POST['texte'].' supprimé');
DEFINE ('r1objetTitre','<h4>Recherche d\'un type de donnée</h4>');
DEFINE ('r1objetChoix','Choix objet');
DEFINE ('r1objetAffiche','<h4>Affichage de l\'objet: '.$_SESSION['libobjet'].'</h4>');
DEFINE ('r1objetLibel','Libellé objet');
DEFINE ('r1objetTaille','taille objet');
DEFINE ('r1objetMini','occurences mini');
DEFINE ('r1objetTyped','type objet');
 
if (isset($_POST['choix']) ) {		// Choix d'un type d'objet effectué
 print_r($_POST);
 $_POST['message'] = "";
 $objet = $_POST['objet'];
 $_SESSION['objet'] = $objet;
 header("Location:"."r1objet.php?objet=$objet"); // Relance avec Id de objet modèle
}

// si Submit effectué et 1er champ du formulaire renseigné
// -------------------------------------------------------
if (isset($_POST['valid']) AND isset($_POST['texte']) AND $_POST['texte'] != NULL ) {	
 $poubelle = array_pop($_POST); 		// éliminer le post du valid
 $poubelle = array_pop($_POST); 		// éliminer le post du message
// print_r($_POST);
 if ($_POST['type'] == "fiche") {
  $_POST['message'] = r1objetType;
 }
 else {
  try {
   $bdd->beginTransaction(); 			// ouvre une transaction
   $lib = $_SESSION['libobjet'].' -';		
   $id = $_SESSION['objet'];
   updateObjet($bdd,$id,$_POST['texte']);
  // unicite_max est forcé à 1
   updateObjetType($bdd,$id,$_POST['mini'],1,$_POST['taille'],$_POST['type']);
   $bdd->commit(); // valide et termine la transaction
// informe l'utilisateur
   $_POST['message'] = r1objetOK;
  } 
  catch(Exception $e) {
   $bdd->rollback();	// invalide la transaction
   $_POST['message'] = r1objetKO;
  }
 }
} 

if (isset($_POST['supp']) AND  $_SESSION['objet'] != NULL ) {
// print_r($_POST); echo '<br>id='.$_SESSION['objet'];
 try {
   $bdd->beginTransaction(); 			// ouvre une transaction
   $id = $_SESSION['objet'];
// vérifier que ce type d'objet n'a pas encore été utilisé
   $options = selectOccFils($bdd,$id);
   if (count($options) > 0 OR $options == '') {
    $_POST['message'] = r1objetExiste;
    $bdd->commit();
   }
   else {
    deleteObjet($bdd,$id);
    deleteObjetType($bdd,$id);
    $bdd->commit();
    $_POST['message'] = r1objetSupprime;
   }
 }
 catch(Exception $e) {
  $bdd->rollback();	// invalide la transaction
  $_POST['message'] = r1objetKO;
 }
}

// sous programme d'affichage du message de retour ou d'erreur
function afficheMessage() {
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
}

// affiche ou ré-affiche le formulaire de saisie des données
 echo '<form method="POST" action="r1objet.php">';
 if (isset($_GET['objet'])) {			// si n° de fiche fourni dans l'url
  $_SESSION['objet'] = $_GET['objet'];		// id du type de fiche sélectionnée
  $donnees = selectId($bdd,$_SESSION['objet']);	// récupération du nom du type de fiche
  $_SESSION['libobjet'] = $donnees[3];		// libellé du pere des fiches
  $_POST['objet'] = $_GET['objet'];		// n° fiche en post
 }
// démarrage: choix du type d'objet
if (count($_POST) == 0) {			// lancement initial du programme (sans n° de fiche)
 echo r1objetTitre;				
 $tabl = selectObjet($bdd,$IdRacObj,'%',0); 	// recherche des objets génériques 
 $imax = count($tabl);
 for ($i=0;$i<$imax;$i++) {			// construit table des options du sélect
  $options[$i][0] = $tabl[$i][0];
  $options[$i][1] = $tabl[$i][1];
 }
 echo '<table><tr>';
 afficheRangTable(r1objetChoix,'objet','select','80',$options,'','');	// affiche sélection d'un type d'objet
 echo '</tr></table><br>';
 afficheMessage();							//
 echo '<hr><input type="submit" name="choix" value="Valider choix" />';	// affiche bouton submit de choix
}

// affichage du champ à saisir pour le type d'objet choisi
else {						// lancement du programme avec n° de fiche choisi
 echo r1objetAffiche;	// pour le type de fiche sélectionné
 if (isset($_SESSION['objet'])) {
  $valeur = $_SESSION['libobjet'].' ';
  $caracteristiques = selectIdType($bdd,$_SESSION['objet']);
  $mini = $caracteristiques[1];
  $maxi = $caracteristiques[2];
  $taille = $caracteristiques[3];
  $type = $caracteristiques[4];			// non utilisé actuellement
  echo '<table><tr>';
  afficheRangTable(r1objetLibel,'texte','text',$taille,$valeur,'','');	// affiche libellé actuel de l'objet
  echo '</tr><tr>';
  afficheRangTable(r1objetMini,'mini','text',5,$mini,'','');
  echo '</tr><tr>';
 // afficheChamp('occurences maxi_ ','maxi','text',5,$maxi,'','');
  afficheRangTable(r1objetTaille,'taille','text',5,$taille,'','');
  $initialisation = initialiseTypes();
  $initialisation[0][2] = $type;
  $typed = "select";
  echo '</tr><tr>';
  afficheRangTable(r1objetTyped,'type',$typed,10,$initialisation,'','');
  echo '</tr></table><br>';
 }
 afficheMessage();	
 echo '<hr><input type="submit" name="valid" value="Modifier type objet" />';	// affiche bouton submit de validation
 $options = selectOccFils($bdd,$_SESSION['objet']);
 if (count($options) == 0 OR $options == '') {		// affiche possibilité de suppression si non utilisé
  echo ' <input type="submit" name="supp" value="Supprimer type objet" />';
 }
}
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
