<?php
// Erreurs, anomalies, remarques revu 26/04/2024 ok
/* **** utiliser $data = htmlentities($_POST[]) pour protéger des attaques Html
protéger ' "  par doublequotes ...
Pas de solution implémentée */
/* Programme de saisie d'occurrence objet
 1. Sélection du type d'objet
 2. Saisie des valeurs possibles de ce objet
 Les doublons type, valeur sont interdits
 **** ne marche plus avec utf8mb4_bin !!!!
*/

session_start(); 			// démarre la session
include('lib/lib.php'); 		// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 			// ouvre la base de données ;
include('lib/ban-menu.php'); 		// affiche entête Html, bannière personnalisée et menu dynamique
autorise(array(0));			// contrôle accès autorisé pour tous
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel
					// initialise $maxselect , nombre de champs de saisie
					
DEFINE ('s2objetCrees',' objets créé(s) ou déjà existants gardés');
DEFINE ('s2objetKO','Erreur ! Rien n\'a été enregistré ou modifié !');
DEFINE ('s2objetTitre','<h4>Saisie données par type de donnée</h4>');
DEFINE ('s2objetChoix','Choix objet ');
DEFINE ('s2objetValider','Valider choix');
DEFINE ('s2objetTitre1','<h4>Saisie données selon le type '.$_SESSION['libobjet'].'</h4>');
DEFINE ('s2objetGuide1','<h4>Création jusqu\'à ');
DEFINE ('s2objetGuide2',' occurrences objet </h4>');
DEFINE ('s2objetEnregistrer','Enregistrer');

if (isset($_POST['choix']) ) {		// Choix d'un type d'objet effectué
 $_POST['message'] = "";
 $objet = $_POST['objet'];
 $_SESSION['objet'] = $objet;
 header("Location:"."s2objet.php?objet=$objet"); // Relance avec Id de objet modèle
}

// si Submit effectué et 1er champ du formulaire renseigné
// -------------------------------------------------------
if (isset($_POST['valid']) AND isset($_POST['texte0']) AND $_POST['texte0'] != NULL ) {	
 $poubelle = array_pop($_POST); 		// éliminer le post du valid
 $poubelle = array_pop($_POST); 		// éliminer le post du message
 $nbocc = count($_POST); 			// nombre d'éléments de $_POST
 try {
  $bdd->beginTransaction(); 			// ouvre une transaction
  $libpere = $_SESSION['libobjet'].' -';		
  $idpere = $_SESSION['objet'];
// crée les occ. objet (Idpere = $_POST['texte'.$c, Texte= $_POST['texte'.$d], visible = 1) 
  $cmax = count($_POST);
  $i = 0;
  for ($c=0;$c<$cmax;$c++) {
//  $libelle = protegeQuotes($_POST['texte'.$c]);
   if (isset($_POST['texte'.$c]) AND strlen($_POST['texte'.$c]) != 0) {
    $libelle = $_POST['texte'.$c];
    $idobjet = insertObjet($bdd,$idpere,$libelle,1); // crée l'occurrence objet visible
    $i++;
   }
  }
  $bdd->commit(); // valide la transaction et informe l'utilisateur
  $_POST['message'] = $i.s2objetCrees;
 } 
 catch(Exception $e) {
  $bdd->rollback();	// invalide la transaction
  $_POST['message'] = s2objetKO;
 }
} 

// sous programme d'affichage du message de retour ou d'erreur
function afficheMessage() {
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
}

// affiche ou ré-affiche le formulaire de saisie des données
 echo '<form method="POST" action="s2objet.php">';
 if (isset($_GET['objet'])) {			// si n° de fiche fourni dans l'url
  $_SESSION['objet'] = $_GET['objet'];		// id du type de fiche sélectionnée
  $donnees = selectId($bdd,$_SESSION['objet']);	// récupération du nom du type de fiche
  $_SESSION['libobjet'] = $donnees[3];		// libellé du pere des fiches
  $_POST['objet'] = $_GET['objet'];		// n° fiche en post
 }
// démarrage: choix du type d'objet
if (count($_POST) == 0) {			// lancement initial du programme (sans n° de fiche)
 echo s2objetTitre;				
 $tabl = selectObjet($bdd,$IdRacObj,'%',0); 	// recherche des objets génériques 
 $imax = count($tabl);
 for ($i=0;$i<$imax;$i++) {			// construit table des options du sélect
  $options[$i][0] = $tabl[$i][0];
  $options[$i][1] = $tabl[$i][1];
 }
 echo '<table><tr>';
 afficheRangTable(s2objetChoix,'objet','select','80',$options,'','');	// affiche sélection d'un type d'objet
 echo '</tr></table><br>';
 afficheMessage();  //
 $valider = s2objetValider;
 echo '<hr><input type="submit" name="choix" value="'.$valider.'" />';	// affiche bouton submit de choix
}
// affichage des champs à saisir pour le type de fiche choisi
else {						// lancement du programme avec n° de fiche choisi
 echo s2objetTitre1;	// pour le type de fiche sélectionné
 echo s2objetGuide1.$maxselect.s2objetGuide2;
 if (isset($_SESSION['objet'])) {
  $label = $_SESSION['libobjet'].' ';
  $caracteristiques = selectIdType($bdd,$_SESSION['objet']);
  $taille = $caracteristiques[3];
  $type = $caracteristiques[4];			// récupère type de l'objet texte, date, number, datalist, fichier, ...	
  						// texte par défaut
  echo '<table>';
  for ($i=0;$i<$maxselect;$i++) {
   echo '<tr>';
   if ($i>0) $label = "";
   afficheRangTable($label,'texte'.$i,$type,$taille,'','','');	// affiche sélection d'un type d'objet
   echo '</tr>';
  }
  echo '</table>';
 }
 echo '<br>'; afficheMessage();
 $enregistrer = s2objetEnregistrer;
 echo '<hr><input type="submit" name="valid" value="'.$enregistrer.'" />';	// affiche bouton submit de validation
							//
}
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
