-- MariaDB dump 10.19  Distrib 10.11.6-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: objet
-- ------------------------------------------------------
-- Server version	10.11.6-MariaDB-0+deb12u1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `objet`
--

DROP TABLE IF EXISTS `objet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `objet` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `IdPere` int(11) NOT NULL,
  `visible` int(11) NOT NULL DEFAULT 1,
  `Texte` varchar(5000) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL COMMENT 'utf8mb4_bin est la seule collation sensible à la casse et aux accents lors d''une recherche !',
  PRIMARY KEY (`Id`),
  KEY `IdPere` (`IdPere`)
) ENGINE=InnoDB AUTO_INCREMENT=1876 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `objet`
--

LOCK TABLES `objet` WRITE;
/*!40000 ALTER TABLE `objet` DISABLE KEYS */;
INSERT INTO `objet` VALUES
(2,0,-1,'__Racine générale__'),
(3,2,-1,'__Racine de tous objets génériques__'),
(4,2,-1,'__Racine de toutes les fiches génériques__'),
(5,2,-1,'__Racine de toutes relations__'),
(1462,3,0,'Nom de personne '),
(1463,3,0,'Prénom '),
(1464,3,0,'Téléphone '),
(1465,3,0,'Mail '),
(1466,3,0,'Ligne adresse'),
(1467,3,0,'Code postal '),
(1468,3,0,'Commune '),
(1469,3,0,'Pays '),
(1470,4,0,'Fiche Adresse'),
(1471,4,0,'Fiche Contact'),
(1473,1462,1,'Duchmol'),
(1474,1463,1,'Christian'),
(1475,1463,1,'Marie'),
(1476,1463,1,'Eugène'),
(1479,1465,1,'duchmol@gmail.com'),
(1480,1465,1,'duchmol@free.fr'),
(1482,1466,1,'Place Etinne Marcel'),
(1483,1467,1,'78180'),
(1484,1468,1,'Montigny le bretonneux'),
(1485,1469,1,'France'),
(1487,1466,1,'1 boulevard Cézanne'),
(1488,1466,1,'2ème étage D'),
(1489,1467,1,'78280'),
(1490,1468,1,'Guyancourt'),
(1527,1467,1,'7271'),
(1528,1468,1,'Dour'),
(1529,1469,1,'Belgique'),
(1546,1462,1,'Bellefille'),
(1547,1463,1,'Françoise'),
(1548,1463,1,'Annick'),
(1549,1463,1,'Micheline'),
(1830,1471,1,'##677d3c1dee429'),
(1831,1464,1,'0987654321'),
(1832,1464,1,'123456789'),
(1833,1470,1,'##677d3c1df17c5'),
(1834,1466,1,'Place Etienne Marcel'),
(1835,1470,1,'##677d3c1df1c01'),
(1836,1471,1,'##677d3cff86de6'),
(1837,1465,1,'bellefille@gmail.com'),
(1838,1470,1,'##677d3cff8b72b'),
(1839,1470,1,'##677d3cff8d529'),
(1840,1466,1,'1 avenue royale'),
(1841,3,0,'Nom de plante'),
(1842,3,0,'Famille de plantes'),
(1843,3,0,'Hauteur plante (cm)'),
(1844,3,0,'Type de plante'),
(1845,3,0,'Couleur des fleurs'),
(1846,4,0,'Fiche plante'),
(1847,1846,1,'##677d3f3cbd7ee'),
(1848,1841,1,'Abutilon'),
(1849,1842,1,'Malvacées'),
(1850,1843,1,'100 - 150'),
(1851,1844,1,'Arbuste à feuilles persistantes'),
(1852,1845,1,'rouge'),
(1853,1846,1,'##677d3f7ac5f43'),
(1854,1841,1,'Acacia linéaris'),
(1855,1842,1,'Miosacées'),
(1856,1843,1,'300 - 800'),
(1857,1844,1,'Arbre à feuille persistantes'),
(1858,1845,1,'jaune'),
(1859,1846,1,'##677d3fe313524'),
(1860,1841,1,'Clarkia'),
(1861,1842,1,'Oenothéracées'),
(1862,1843,1,'50 - 110'),
(1863,1844,1,'Annuelle'),
(1864,1845,1,'rose'),
(1865,1846,1,'##677d4041a8161'),
(1866,1841,1,'Clématite à grandes fleurs'),
(1867,1842,1,'Renonculacées'),
(1868,1843,1,'300 - 500'),
(1869,1844,1,'Grimpante à feuilles caduques'),
(1870,1845,1,'violet'),
(1871,1846,1,'##677d40c1d75c5'),
(1872,1841,1,'Glycine de Chine'),
(1873,1842,1,'Papilionacées'),
(1874,1843,1,'500 - 1500'),
(1875,1845,1,'bleu');
/*!40000 ALTER TABLE `objet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `objet_type`
--

DROP TABLE IF EXISTS `objet_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `objet_type` (
  `Id` int(11) NOT NULL,
  `unicite_min` int(11) NOT NULL DEFAULT 1,
  `unicite_max` int(11) NOT NULL DEFAULT 1,
  `taille` int(11) NOT NULL DEFAULT 0,
  `type` text NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `objet_type`
--

LOCK TABLES `objet_type` WRITE;
/*!40000 ALTER TABLE `objet_type` DISABLE KEYS */;
INSERT INTO `objet_type` VALUES
(1462,1,1,30,'texte'),
(1463,1,1,30,'texte'),
(1464,1,1,12,'texte'),
(1465,1,1,40,'texte'),
(1466,1,2,50,'texte'),
(1467,1,1,10,'texte'),
(1468,1,1,40,'texte'),
(1469,1,1,30,'texte'),
(1470,1,1,50,'fiche'),
(1471,1,1,50,'fiche'),
(1816,1,1,50,'texte'),
(1817,1,1,50,'texte'),
(1818,1,1,50,'texte'),
(1841,1,1,50,'texte'),
(1842,1,1,50,'texte'),
(1843,1,1,50,'texte'),
(1844,1,1,50,'texte'),
(1845,1,1,50,'texte'),
(1846,1,1,50,'fiche');
/*!40000 ALTER TABLE `objet_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `relation`
--

DROP TABLE IF EXISTS `relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `relation` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `IdCompose` int(11) NOT NULL,
  `IdComposant` int(11) NOT NULL,
  `IdNombre` int(11) DEFAULT 1,
  PRIMARY KEY (`Id`),
  KEY `relation_ibfk_2` (`IdComposant`),
  KEY `relation_ibfk_1` (`IdCompose`),
  CONSTRAINT `relation_ibfk_1` FOREIGN KEY (`IdCompose`) REFERENCES `objet` (`Id`) ON DELETE CASCADE,
  CONSTRAINT `relation_ibfk_2` FOREIGN KEY (`IdComposant`) REFERENCES `objet` (`Id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=2725 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `relation`
--

LOCK TABLES `relation` WRITE;
/*!40000 ALTER TABLE `relation` DISABLE KEYS */;
INSERT INTO `relation` VALUES
(1856,1470,1466,2),
(1857,1470,1467,1),
(1858,1470,1468,1),
(1859,1470,1469,1),
(1884,1471,1462,1),
(1885,1471,1463,3),
(1886,1471,1464,2),
(1887,1471,1465,3),
(1888,1471,1470,4),
(2661,1830,1473,1),
(2662,1830,1474,1),
(2663,1830,1475,1),
(2664,1830,1476,1),
(2665,1830,1831,1),
(2666,1830,1832,1),
(2667,1830,1479,1),
(2668,1830,1480,1),
(2669,1830,1833,1),
(2670,1833,1834,1),
(2671,1833,1483,1),
(2672,1833,1484,1),
(2673,1833,1485,1),
(2674,1830,1835,1),
(2675,1835,1487,1),
(2676,1835,1489,1),
(2677,1835,1490,1),
(2678,1835,1485,1),
(2679,1836,1546,1),
(2680,1836,1547,1),
(2681,1836,1548,1),
(2682,1836,1549,1),
(2683,1836,1831,1),
(2684,1836,1837,1),
(2685,1836,1838,1),
(2686,1838,1487,1),
(2687,1838,1489,1),
(2688,1838,1490,1),
(2689,1838,1485,1),
(2690,1836,1839,1),
(2691,1839,1840,1),
(2692,1839,1527,1),
(2693,1839,1528,1),
(2694,1839,1529,1),
(2695,1846,1841,1),
(2696,1846,1842,1),
(2697,1846,1843,1),
(2698,1846,1844,1),
(2699,1846,1845,1),
(2700,1847,1848,1),
(2701,1847,1849,1),
(2702,1847,1850,1),
(2703,1847,1851,1),
(2704,1847,1852,1),
(2705,1853,1854,1),
(2706,1853,1855,1),
(2707,1853,1856,1),
(2708,1853,1857,1),
(2709,1853,1858,1),
(2710,1859,1860,1),
(2711,1859,1861,1),
(2712,1859,1862,1),
(2713,1859,1863,1),
(2714,1859,1864,1),
(2715,1865,1866,1),
(2716,1865,1867,1),
(2717,1865,1868,1),
(2718,1865,1869,1),
(2719,1865,1870,1),
(2720,1871,1872,1),
(2721,1871,1873,1),
(2722,1871,1874,1),
(2723,1871,1869,1),
(2724,1871,1875,1);
/*!40000 ALTER TABLE `relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `usager`
--

DROP TABLE IF EXISTS `usager`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `usager` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `passe` text NOT NULL,
  `nom` text NOT NULL,
  `prenom` text NOT NULL,
  `profil` int(11) NOT NULL,
  `email` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usager`
--

LOCK TABLES `usager` WRITE;
/*!40000 ALTER TABLE `usager` DISABLE KEYS */;
INSERT INTO `usager` VALUES
(1,'b89f7a5ff3e3a225d572dac38b2a67f7','Admin','Admin',9,'admin@gmail.com');
/*!40000 ALTER TABLE `usager` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2025-01-07 17:45:09
