<?php
// programme d'export de toute la base
include('lib/lib.php');
// initialise $host, $param2, $param3, $options, $base, $param1?
$bdd = ouvreBase();
// affichage de l'entête Html, de la bannière et du menu dynamique
include('lib/ban-menu.php'); 
autorise(array(5,9));			// contrôle accès autorisé pour admin et gestionnaire

DEFINE ('exportbaseTitre','<h4>Sauvegarde de la base Objet</h4>');
DEFINE ('exportbaseGuide','<p class="mode-emploi">Mode d\'emploi:<br/>Modifier le nom de la sauvegarde si nécessaire.<br/>Puis appuyer sur le bouton <b>Sauvegarder</b>.<br/><br/>La sauvegarde n\'est pas instantanée ! Veuiller patienter quelques instants.</p>');
DEFINE ('exportbaseEncours','La base ".$base." est en cours de sauvegarde ... ');
DEFINE ('exportbaseOK',' Base ');
DEFINE ('exportbaseOK1',' sauvegardée dans fichier ');
DEFINE ('exportbaseErr','Erreur ! ');
DEFINE ('exportbaseKO',' (1) Incident mineur ? de sauvegarde');
DEFINE ('exportbaseKO1','(2) Fichier ');
DEFINE ('exportbaseKO2',' non trouvé ou accès interdit ');
DEFINE ('exportbaseNomfic','Nom du fichier de sauvegarde ');
DEFINE ('exportbaseSave','Sauvegarder base');

$date_save = new DateTime();
$nomsave = $base.'-'.$date_save->format('Ymd-H:i').".sql";
$message = "";
$retour = 0;	// code retour d'une commande system



// Action d'export en sql de la base
if (isset($_POST['sauver'])) {
 $param2 = "admin@localhost";
 $nomsave = $_POST['nomsave'];
 $_POST['message'] = exportbaseEncours;

//$commande = 'mysqldump --opt -u'.$param2.' -p'.$param3.' '.$base.' > ./save/'.$nomsave;
 $commande = 'mysqldump --opt -uadmin -ppasse objet > ./save/'.$nomsave;
 system($commande,$retour);
 if ($retour == 0)
  $_POST['message'] = exportbaseOK.$base.exportbaseOK1.$nomsave;
 elseif ($retour == 1) $_POST['message'] = exportbaseKO;
 elseif ($retour == 2) $_POST['message'] = exportbaseErr.exportbaseKO1.$nomsave.exportbaseKO2;
// l'erreur 2 se produit souvent à cause des droits d'accès
 else $_POST['message'] = exportbaseErr.$retour;
}

// Début du formulaire
echo '<form method="POST" action="exportbase.php">';
echo exportbaseTitre;
echo exportbaseGuide;
echo '<a href="./aide/exportbase.html" target="_blank">Aide en ligne</a>';
echo '<table><tr>';
afficheRangTable(exportbaseNomfic,'nomsave','text','20',$nomsave,'','');
echo '</tr><tr>';
afficheRangTable('','sauver','submit','3',exportbaseSave,' ','','');
echo '</tr><table>';
if (isset($_POST['message']))
 afficheChamp('','message','text','80',$_POST['message'],'','Readonly');
else
 afficheChamp('','message','text','80',$message,'','Readonly');
echo '</form>';
include('lib/pied.php');
?>
