<?php
/* But de ce programme: Initialiser l'application
 Soit créer la racine de tous les objets ou fiches
*/
if (!isset($_SESSION)) session_start(); 		// démarre la session
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé par les profils Aministrateur
autorise(array(9));
initConstantes();

//echo $libracgen;
// si Submit effectué et 1er champ du formulaire renseigné
// -------------------------------------------------------
if (isset($_POST['init']) ) {	
 $poubelle = array_pop($_POST); 			// éliminer le post du valid
 $poubelle = array_pop($_POST); 			// éliminer le post du message
/* analyse du tableau $_POST en vue enlever la protection par \
 et de supprimer les adresses non renseignées.
*/ 
 $Id = selectTexte($bdd,$libracgen,-1);
 if (isset($Id)) 
  $_POST['message'] = 'Abandon: application initialisée (Racine générale déjà créée)';
 else {
 try {								// début essai traitement
  $bdd->beginTransaction(); 					// ouvre une transaction
// IdRacGen réinitialisé à 1
// crée l'occ. objet racine générale IdPere = NULL 
//  (Id=autoincrement, IdPere=NULL, Texte="Racine générale", visible = -1)
//  sauvegarder Id dans IdRacGen 
// INSERT INTO objet (IdPere, visible, Texte) VALUES (NULL,0,'Racine générale')
   $req = $bdd->prepare( '
   INSERT INTO objet (IdPere,visible,Texte) 
   VALUES (:idpere,:visible,:texte ) ' )
   or die(print_r($bdd->errorInfo()) );
   $req->execute(array(':idpere' => 0,':texte' => $libracgen, ':visible' => -1 )) 
   or die(var_dump($bdd->errorInfo()));
   $IdRacGen = $bdd->lastinsertid();
//echo 'IdRacGen='.$IdRacGen;
// crée l'occ. objet racine de tous les modèles d'objets 
//  (Id=autoincrement, IdPere=IdRacGen, Texte="Racine de tous objets", visible = -1)
//  sauvegarder Id dans IdRacObj 
   $req = $bdd->prepare( '
   INSERT INTO objet (IdPere,Texte,visible) 
   VALUES (:idpere,:texte,:visible ) ' )
   or die(print_r($bdd->errorInfo()) );
   $req->execute(array('idpere' => $IdRacGen,'texte' => $libracobj,'visible' => -1, )) 
   or die(var_dump($bdd->errorInfo()));
   $IdRacObj = $bdd->lastinsertid();
//echo 'IdRacObj='.$IdRacObj;
// crée l'occ. objet_type de la racine de tous les modèles d'objets 
//  (Id=IdRacObj, unicite_min=1, unicite_max=1, size=0, type="texte", ...) 
   $req = $bdd->prepare( '
   INSERT INTO objet_type (Id,size,type) 
   VALUES (:id,:size,:type ) ' )
   or die(print_r($bdd->errorInfo()) );
   $req->execute(array('id' => $IdRacObj,'size' => 0,'type' => 'texte' )) 
   or die(var_dump($bdd->errorInfo()));

// crée l'occ. objet_type de la racine de tous les modèles de fiches
//  (Id=IdRacObj, unicite_min=1, unicite_max=1, size=0, type="texte", ...) 
   $req = $bdd->prepare( '
   INSERT INTO objet (IdPere,Texte,visible) 
   VALUES (:idpere,:texte,:visible ) ' )
   or die(print_r($bdd->errorInfo()) );
   $req->execute(array('idpere' => $IdRacGen,'texte' => $libracfic,'visible' => -1, )) 
   or die(var_dump($bdd->errorInfo()));
   $IdRacFic = $bdd->lastinsertid();
//echo 'IdRacFic='.$IdRacFic;
// crée l'occ. objet racine de tous les modèles de relations 
//  (Id=autoincrement, IdPere=IdRacGen, Texte="Racine de toutes relations", visible = 0)
//  sauvegarder Id dans IdRacRel 
   $req = $bdd->prepare( '
   INSERT INTO objet (IdPere,Texte,visible) 
   VALUES (:idpere,:texte,:visible ) ' )
   or die(print_r($bdd->errorInfo()) );
   $req->execute(array('idpere' => $IdRacGen,'texte' => $libracrel,'visible' => -1, )) 
   or die(var_dump($bdd->errorInfo()));
   $IdRacRel = $bdd->lastinsertid();

   $bdd->commit(); 							
   $_POST['message'] = 'Initialisation effectuée';	// informe l'utilisateur
 } 								
 catch(Exception $e) {						
  $bdd->rollback();						
  $_POST['message'] = 'Initialisation refusée !';	// informe l'utilisateur
 }
 }
}

// affiche ou ré-affiche le formulaire de saisie des données
 echo '<form method="POST" action="init.php">';
 echo '<h4>Initialisation de l\'application</h4>';
 echo '<p>Crée les occurrences racines objet et relation dans table objet.<br/>Crée les occurences correspondantes dans objet_type.</p>';

// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 echo '<hr><input type="submit" name="init" value="Initialiser" />';
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
