<?php
// Erreurs, anomalies, remarques
/* **** utiliser $data = htmlentities($_POST[]) pour protéger des attaques Html
Pas de solution implémentée */

/* But de ce programme: Modifier ou supprimer une fiche générique existante
 cad Ajouter si nécessaire de nouveaux objets ou supprimer totalement la fiche si aucune création d'occ. fiches n'existe déjà
 On peut ajouter une sous fiche mais toujours en dernier dans la liste !!! (restriction d'usage)
*/
if (!isset($_SESSION)) session_start(); 		// démarre la session
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé par le profil Aministrateur seul
autorise(array(5,9));
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel
					// fixe aussi le nombre d'objets sélectionnables $maxselect

// si Submit effectué et 1er champ du formulaire renseigné
// -------------------------------------------------------
if (isset($_POST['valid']) AND isset($_POST['texte0']) AND $_POST['texte0'] != NULL ) {	
 $poubelle = array_pop($_POST); 			// éliminer le post du valid
 $poubelle = array_pop($_POST); 			// éliminer le post du message
 $nbpost = count($_POST);
// fiche inchangée
 $idfiche = $_POST['texte0'];
 try {
  $bdd->beginTransaction(); 			// ouvre une transaction
// supprime les anciennes relations avant création de nouvelles
  deleteComposant($bdd,$idfiche);

// crée nouvelles relations 
 for ($c=1;$c<$nbpost;$c++) {
  if ($_POST['texte'.$c] != "") { 
   $idobjet = $_POST['texte'.$c];			// récup Id objet générique
   if (isset($_POST['repet'.$c]))
    $nombre = $_POST['repet'.$c];			// récup facteur répétition saisi
   else
    $nombre = 1;					// valeur par défaut
   insertRelation($bdd,$idfiche,$idobjet,$nombre); 	// crée relation fiche générique -> objet générique
  }
 }
 $bdd->commit(); // valide et termine la transaction
// informe l'utilisateur
   $_POST['message'] = 'Fiche N° '.$idfiche.' modifiée';
 } 

 catch(Exception $e) {
  $bdd->rollback();	// invalide la transaction
  $_POST['message'] = 'Erreur ! Rien n\'a été modifié !';
 }
}

// suppression d'une fiche générique
if (isset($_POST['supp']) AND isset($_POST['texte0']) AND $_POST['texte0'] != NULL ) {	
 $poubelle = array_pop($_POST); 			// éliminer le post du valid
 $poubelle = array_pop($_POST); 			// éliminer le post du message
 $idfiche =  intval($_POST['texte0']);
 // la fiche a-t-elle déjà au moins une occ. fiche créée ?
 $existe = existeObjetFils($bdd,$idfiche,1);
 if (!$existe) {	// si non
  try {
   $bdd->beginTransaction(); 			// ouvre une transaction
   deleteObjet($bdd,$idfiche);
   deleteObjetType($bdd,$idfiche);
 // normalement les relation sont supprimées par la relation objet à relation avec contrainte cascading en suppression
   deleteRelation($bdd,$idfiche,NULL);
   $_POST['message'] = 'Suppression effectuée'; 
   $bdd->commit(); // valide et termine la transaction  
  }
   catch(Exception $e) {
    $bdd->rollback();	// invalide la transaction
    $_POST['message'] = 'Erreur ! Rien n\'a été modifié !';
  } 
 }
 else {			// si oui, suppression interdite
  $_POST['message'] = 'Erreur ! Suppression interdite car existe déjà une occurrence de fiche créée !'; 
 }
}

// affiche ou ré-affiche le formulaire de saisie
 echo '<form method="POST" action="m1fiche.php">';
if (isset($_GET['fiche'])) {
 $idfiche = $_GET['fiche'];
 $donnees = selectId($bdd,$idfiche);
 $libfiche = $donnees[3];
  echo '<h4>Modification de la '.$libfiche.'</h4>';
 echo '<p>Ajouter des types d\'objet par sélection des types proposés. <br/>Laisser à "Choix non retenu", les types d\'objet inutiles.<br/>Ici, il est possible d\'ajouter une sous fiche générique si nécessaire <b>mais seulement en dernier de la liste.</b><br/>Cette sous fiche doit avoir été créée au préalable.<br/>Enfin appuyer sur le bouton Modifier type de  fiche.<br>Le bouton Supprimer apparaît si la fiche n\'a pas d\'occurrences.</p>';

 echo '<table><tr>';
 afficheRangTable('Nom Fiche_ ','texte','text','50',$libfiche,'','Readonly');
 echo '</tr></table>';
 echo '<input type="hidden" name="texte0" value="'.$idfiche.'" />';
// Sélection de tous les objets possibles
 $typeobjets = selectObjet($bdd,$IdRacObj,'%',0);// recherche de tous types d'objet générique
 $options[0][0] = '';				// ajoute d'abord choix non retenu
 $options[0][1] = 'Choix non retenu';
 $nbtype = count($typeobjets);
 for ($t=0;$t<$nbtype;$t++) {			// puis tous les types d'objets
  $to = $t+1;
  $options[$to][0] = $typeobjets[$t][0];
  $options[$to][1] = $typeobjets[$t][1];
 } 
// selection de toutes les fiches possibles sauf elle-même
 $typefiches = selectObjet($bdd,$IdRacFic,'%',0);// recherche des types de fiche générique
 $nbtypef = count($typefiches);
 for ($t=0;$t<$nbtypef;$t++) {	// puis tous les types de fiches sauf elle-même
  $to = $nbtype+$t+1;
  if ($typefiches[$t][0] != $idfiche) {
   $options[$to][0] = $typefiches[$t][0];
   $options[$to][1] = $typefiches[$t][1];
  }
 }
// recherche des objets composants de la fiche
 $composants = selectComposant($bdd,$idfiche);	
 if ($composants != "") {
  $antsmax = count($composants);		// nombre de choix initialisés
  echo '<table>';
  for ($i=0;$i<$maxselect;$i++) {		// affiche les imax choix  
   if ($i <= $antsmax)
    $options[0][2] = $composants[$i][0];
   else
    unset($options[0][2]);
   $j = $i+1;
   echo '<tr>';
   afficheRangTable('Objet'.$j,'texte'.$j,'select','10',$options,' ','');
// lit facteur de répétition actuel IdNombre de relation  
   if (isset($composants[$i][0]))
    $nombre = selectRelation($bdd,$idfiche,$composants[$i][0]);
   else
    $nombre = '';
   afficheRangTable('Répétition'.$j,'repet'.$j,'text','3',$nombre,'','');
   echo '</tr>';
  }
  echo '</table>';
 }
// recherche si la fiche a des occurences filles (visibles) pour interdire suppression
 $fils = existeObjetFils($bdd,$idfiche,1);
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 echo '<hr><input type="submit" name="valid" value="Modifier type de fiche" />';
 if (!$fils)
  echo ' <input type="submit" name="supp" value="Supprimer type de fiche" />';
}
else
 afficheChamp('','message','text','100',$_POST['message'],'','Readonly');

?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
