<?php
// Erreurs, anomalies, remarques
/* **** utiliser $data = htmlentities($_POST[]) pour protéger des attaques Html
Pas de solution implémentée */
// Dernière modif le: 9/04/2024

/* But de ce programme: Modifier ou supprimer une occ. d'objet
 La suppression d'un objet est interdite s'il est référencé plus d'une fois comme composant en table relation
 La modification du libellé d'un objet est autorisée même si le nouveau libellé existe déjà pour ce type d'objet; dans
 ce cas l'Id de l'ancien libellé est remplacé par l'Id du nouveau dans le champ IdComposant de relation, puis l'objet
 correspondant à l'ancien libellé inutile est supprimé.
 ** le traitement se fait bien mais la sortie du prog est à revoir
 *** la lecture de rozé ou Rozé ou roze trouve toujours Rozé ! C'est pratique en recherche générale  mais ça pose problème en recherche stricte ! Est-un pb PDO ou mysql ??
*/

if (!isset($_SESSION)) session_start(); 		// démarre la session
include('lib/lib.php'); 				// inclue fonctions génériques
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé par les profils Aministrateur et Gestionnaire
autorise(array(5,9));					// contrôle accès
initBase($bdd);		// récup $IdRacGen, $IdRacObj, $IdRacFic et $IdRacRel

// si demande de modification
if (isset($_POST['modifier']) AND isset($_POST['texte']) AND $_POST['texte'] != NULL ) {	
 $poubelle = array_pop($_POST); 			// éliminer le post du valid
 $poubelle = array_pop($_POST); 			// éliminer le post du message
// print_r($_POST);
 try {					// début essai traitement
  $bdd->beginTransaction(); 		// ouvre une transaction 
  $idpere = $_POST['pere'];
  $idobjet = $_POST['objet'];		// Id ancien objet
  $libelle = $_POST['texte'];
// vérifie si couple (texte,type objet) est unique
  $options = selectObjet($bdd,$idpere,$libelle,1);
  if (count($options) > 0) {
   $idobjetex = $options[0][0];			//Id de l'objet recherché existant 
   updateComposant($bdd,$idobjet,$idobjetex);	// remplacer IdComposant = $idobjet par $idobjetex
   // si pas de composant trouvé, continue le traitement
   if ($idobjet != $idobjetex)			// en fait si libellé a été changé
    deleteObjet($bdd,$idobjet);			// supprimer l'ancien objet inutile
   $_POST['message'] = '(Objet '.$libelle.') existe déjà, changements correspondants effectués !';
  }
  else { 
// modifie texte de l'objet; 
   $idobjet = updateObjet($bdd,$_POST['objet'],$libelle,1);
   $_POST['message'] = '(Objet '.$_POST['objet'].') '.$libelle.' bien modifié; ';// informe l'utilisateur
  }
  $bdd->commit(); 						// INvalide et termine la transaction	
 }
 catch(Exception $e) {						// si incident durant l'essai
   $bdd->rollback();						// invalide la transaction
   $_POST['message'] = 'Erreur ! Rien n\'a été modifié !';	// informe l'utilisateur
 } // fin essai traitement
}

// si demande de suppression
if (isset($_POST['supprimer']) AND isset($_POST['objet']) AND $_POST['objet'] != NULL) {
   try {						// début essai traitement
    $bdd->beginTransaction(); 				// ouvre une transaction   
    $composes = selectCompose($bdd,$_POST['objet']);	// recherche des relations qui ont cet Id d'objet comme IdComposant
    if (count($composes) == 0) {			// s'il n'y en pas on efface
     $options = selectId($bdd,$_POST['objet']);
     $libelle = $options[3];
     deleteObjet($bdd,$_POST['objet']);	// contrôle cascading en base; efface aussi les relations ayant cet Id d'objet comme IdCompose
     $message = 'Objet '.$libelle.' a été supprimé.';
     header("Location:"."r2objet.php?message=".$message); // Relance recherche avec message suppression effectuée
    }
    else {
     $_POST['message'] = 'Objet '.$libelle.' non supprimé car référencé en relation ! '; 
    }
    $bdd->commit();   					// transaction validée  
   }
   catch(Exception $e) {				// si incident durant l'essai
    $bdd->rollback();					// invalide la transaction
    $_POST['message'] = 'Erreur ! Rien n\'a été supprimé !'; // informe l'utilisateur
  }
  
}

// affiche ou ré-affiche le formulaire de saisie des données
 echo '<form method="POST" action="m2objet.php">';
 echo '<h4>Modification ou suppression occ. d\' objet</h4>';
 echo '<p>Modifier le libellé de l\'objet puis appuyer sur le bouton Modifier.<br/>Si la modification crée un doublon, la modification est refusée.<br/>Si le bouton Supprimer apparaît, on peut effectuer la suppression.<br/>Nota: la suppression est interdite si l\'objet est utilisé par une fiche</p>';
$supp = FALSE;
$modif = TRUE;
if (isset($_GET['objet'])) 
 $idobjet = $_GET['objet'];
elseif (isset($_POST['objet'])) 
 $idobjet = $_POST['objet'];
else {
 $idobjet = '';
}
if ($idobjet != '') {
 $objets = "";
 $objets = selectId($bdd,$idobjet);
 $objettypes = selectIdType($bdd,$idobjet);
 $taille = $objettypes[3];
 if (count($objets) > 2) {
  $pere = $objets[1];
  $donneespere = selectId($bdd,$pere);
  $libelobjet = $donneespere[3];
  $texte = $objets[3]; 
  echo '<table><tr>';
  afficheRangTable($libelobjet.' ','texte','text',$taille,$texte,'','');
  echo '</tr></table><br>';
  echo '<input type="hidden" name="objet" value="'.$idobjet.'" />';
  echo '<input type="hidden" name="pere" value="'.$pere.'" />'; 
// recherche si objet référencé n'appparaît qu'une fois comme composant dans relation
  $options = selectCompose($bdd,$idobjet);
  if (count($options) > 1)
   $supp = FALSE;	// interdire suppression car utilisé dans plusieurs occ. relation
  else
   $supp = TRUE;
 }
 else {
  $_POST['message'] = 'erreur ! id objet non trouvé';
  $modif = FALSE;
 } 
}
// affiche ligne message et bouton de soumission
if (isset($_POST['message']))
 afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
else
 afficheChamp('','message','text','100','','','Readonly');
if ($modif)
 echo '<hr><input type="submit" name="modifier" value="Modifier objet" />';
if ($supp)
 echo ' <input type="submit" name="supprimer" value="Supprimer objet" />';
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
