<?php 
// Références croisées entre programmes et fonctions
// affichage de l'entête Html, de la bannière et du menu dynamique
include('lib/lib.php');
$bdd = ouvreBase();
include('lib/ban-menu.php'); 
// contrôle accès autorisé par le profil Aministrateur seul
autorise(array(9));
DEFINE ('r0refcroTitre','<h4>Références croisées</h4>');
DEFINE ('r0refcroGuide1','Pour chacun des programmes de la liste, recherche les fonctions qui sont utilisées dans lib<br/>');
DEFINE ('r0refcroGuide2','<b>Attention: la fonction selectRelation est utilisée par la fonction afficheForme.</b><br/>');
DEFINE ('r0refcroNb','nb lignes fonctions = ');
DEFINE ('r0refcroKO','Echec: Impossible d\'explorer le dossier');
DEFINE ('r0refcroFonctions','<th>Fonctions</th>');
DEFINE ('r0refcroListe','<br/><br/>Liste des fonctions inutilisées:<br/>');

echo r0refcroTitre;
echo r0refcroGuide1;
echo r0refcroGuide2;
// construction de la liste des fonctions $table_fonction
$table_lib=file("lib/lib.php");		// charge table des fonctions
$nblines = count($table_lib);
echo r0refcroNb.$nblines.'<br>';
$motif = '#^function(.+)\(.+{$#';
//$motif = '#^function(.+)\(.+{$#';
$c = 0;
for ($l=0;$l<$nblines;$l++) {
 if (substr($table_lib[$l],0,8) == "function") {
  $table_fonction[$c] = preg_replace($motif,'$1',$table_lib[$l]); 
  $table_fonction[$c] = trim($table_fonction[$c]);
////
 if (substr($table_fonction[$c],0,20) == "function insertObjet")
  $table_fonction[$c] = "insertObjet";		// correction bug !!!!
////
  $c++;
 }
}
$cmax=count($table_fonction);

$dir = opendir(".");
if (false === $dir) {
    echo r0refcroKO;
} else {
    $prog[0] = "";	// réservé pour colonne fonctions
    $f = 1;
    while ($file = readdir($dir)) { // fin de répertoire retourne FALSE
        // Affichage du nom du fichier (ou sous-répertoire)
      if (($file != 'lib') && ($file!= '..') && ($file!= '.') && ($file!= '.DS_Store') && ($file!= 'documentation') && ($file!= 'import') && ($file != 'logout.php') && ($file!= 'index.php') && ($file!= 'login.php') && ($file!= 'a1refcro.php')  && ($file!= 'favicon.ico') && ($file!= 'index.css') && ($file!= 'importbase.php') && ($file!= 'exportbase.php') && ($file!= 'objet.sql') && ($file!= 'suivi.odt') && ($file!= 'aide') && ($file!= 'doc et suivi') && ($file!= 'i0base.php') && ($file!= 'e0base.php') && ($file!= 'export'))
        $prog[$f] = $file;
        $f++;
    }
    closedir($dir);
}
// la suppression de fichiers ou répertoires déorganise l'index du tableau d'où
$prog = array_values($prog);		// la réindexation en consécutif nécessaire
$nbprog = count($prog);

// affichage html
 print '<table border="1">';
// affichage légende haut
 print r0refcroFonctions;
 for ($p=1;$p<$nbprog;$p++) {
  $pg = substr($prog[$p],0,-4);		// nom du programme, pour réduire largeur colonne
  print '<th>'.$pg.'</th>';
 }
 print r0refcroFonctions;

 for ($f=0;$f<$cmax;$f++) {		// pour chaque ligne du tableau	(fonction)
  $util_fonction[$f] = FALSE;
  for ($p=0;$p<=$nbprog;$p++) {		// pour chaque colonne du tableau (prog)
   if ($p==0) {				// si 1ère col affiche nom de fonction
    print '<tr><td>'.$table_fonction[$f].'</td>';
   }
   elseif ($p<$nbprog) {		// si col suivantes (prog)
    $table_prog = file($prog[$p]);
    $nblines = count($table_prog);	// récupère nombre de lignes du prog
    $trouve = FALSE;
    for ($l=0;$l<$nblines;$l++) {	// pour chaque ligne du prog
     $motif = '#^.*'.$table_fonction[$f].'\(.*$#';
     if (preg_match($motif,$table_prog[$l]) AND !preg_match('#include#',$table_prog[$l])) {
      $util_fonction[$f] = TRUE;
      $trouve = TRUE;
      break;
     }
    }
    if ($trouve) print '<td>X</td>';
    else print '<td> </td>';   
   }
   if ($p==$nbprog) {				// si 1ère col affiche nom de fonction
    print '<td>'.$table_fonction[$f].'</td>';
   }
  }
  print '</tr>';
 }
 print '</table>';

// affichage des fonctions inutilisées
 print r0refcroListe;
 $liste = "";
 for ($f=0;$f<$cmax;$f++) {
  if ($table_fonction[$f] != "selectRelation") {  
   if (!$util_fonction[$f] ) {
    $liste = $liste.$table_fonction[$f].', ';
   }
  }
 }
 print substr($liste,0,-2).'.<br/>';
?>
</p>
<?php
include('lib/pied.php');
?>
