<?php
/* Erreurs, Anomalies, remarques
*** enrichir la recherche multi critères avec booléen ET OU sur l'ensemble
*/ 
/* But de ce programme: Rechercher les données selon un type/modèle de fiche existant
 Affiche un tableau des fiches et des données de ces fiches trouvées (limité à 20);
 Donne la possibilité de modifier ou supprimer une fiche par m2fiche, de modifier ou supprimer un objet par m2objet
 Dernière mise à jour: 22/04/2024
 *** erreur n'affiche pas le n° de téléphone après un importdivers ; liens dans relation corrects !!
*/
if (!isset($_SESSION)) session_start(); // démarre la session
include('lib/lib.php'); 		// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 			// ouvre la base de données ;
include('lib/ban-menu.php'); 		// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé à tous
autorise(array(0));
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

DEFINE ('r2ficheLegende','<br><b>Fiches trouvées suivies( ...) des fiches amont retrouvées</b></br><br>');
DEFINE ('r2ficheTrouves',' trouvé(s)');
DEFINE ('r2ficheAucun','Attention ! Aucune fiche trouvée !');
DEFINE ('r2ficheErr','Erreur ! Rien retrouvé !');
DEFINE ('r2ficheTitre','<h4>Recherche données par fiche</h4>');
DEFINE ('r2ficheChoix','Choix');
DEFINE ('r2ficheValider','Valider choix');
DEFINE ('r2ficheTitre1','<h4>Recherche données selon fiche '.$_SESSION['libfiche'].'</h4>');
DEFINE ('r2ficheGuide1','<p>Utiliser le % comme joker pour sélectionner<br/>Exemple1: c% retrouve toute expression commençant par lettre c<br/>Exemple2: %ol% retrouve toute expression contenant ol<br/>Exemple3: %ian retrouve toute expression finissant par ian<br/>On peut combiner; la recherche est sensible à la casse et aux accents</p>');
DEFINE ('r2ficheRechercher','Rechercher');
DEFINE ('r2ficheCasse','Recherche sensible à la casse');
DEFINE ('r2ficheBooleen','Combinaison des critères');

if (isset($_POST['choix']) ) {				// Choix d'un type de fiche effectué
 $_SESSION['idfiche'] = $_POST['fiche'];		// Récupère son id
 $fiches = selectId($bdd,$_POST['fiche']);		// Recherche son libellé
 $_SESSION['libfiche'] = $fiches[3];
 $_POST['message'] = ""; 
}

if (isset($_POST['terminer']) ) {					// Demande autre choix
 unset($_SESSION['fiche']);					// supprime variable de session pour réinit process.
 die('fin de la recherche');
 $_POST['message'] = "";
}

if (isset($_POST['recher']) ) {					// Submit de recherche effectué
 $poubelle = array_pop($_POST); 				// éliminer le post du message
 $poubelle = array_pop($_POST); 				// éliminer le post du recher
// print_r($_POST);
 $casse =  $_POST['casse']; 
 $condition = $_POST['condition'];
 $imax = (count($_POST)-2)/2;
 $idebut = 0;
 $f = 0;
 $tableIdd = array();
 $tableIdi = array();
 $autrefiche = FALSE;
 while ($idebut < $imax && $f <2 ) {	// pour tous les critères relatifs à un même type de fiche
  $ir = 0;
  for ($i=$idebut;$i<$imax;$i++) { // Pour chacun des critères positionnés avec son Idpere recherche dans table objet
   $libelle = $_POST['texte'.$i];
   $idpere = $_POST['idpere'.$i];   
   $idgpere = selectIdPere($bdd,$idpere);
   if ($idgpere == $IdRacFic) {
    $idebut = $i+1; 	// pointe la première donnée de la fiche suivante
    $autrefiche = TRUE;
    break;		// sortie immédiate boucle
   }
   else {  
    if (isset($libelle) AND $libelle !="" ) {	// si critère positionné et renseigné (élimine les fiches !!)
     $tabfiches = selectFiches($bdd,$idpere,$libelle,$casse); // retourne les clés des fiches trouvées
////echo '<br><br>tabfiches i='.$i.' '; print_r($tabfiches);
     $nbf = count($tabfiches);
     if ($nbf > 0 ) {
      $tableIdi[$f][$i] = $tabfiches;
     }
////if (isset($tableIdi[$f][$i])) {echo '<br><br>i='.$i.' '; print_r($tableIdi[$f][$i]); }
    }
   }
  } 
////if ($f == 0) { echo '<br><br> tableIdi[0] '; print_r($tableIdi[0]); }
////if ($f == 1) { echo '<br><br> tableIdi[1] '; print_r($tableIdi[1]); } 
// Fait le Ou logique ou bien le Et logique des Id retrouvés pour cette fiche 
  $d=0;
  $tableId[$f] = array();
  if ($condition == 0) {	// Ou logique sur critères d'une même fiche
   for ($i=0;$i<$imax;$i++) {
    if (isset($tableIdi[$f][$i]) && count($tableIdi[$f][$i]) > 0) {
     $tableId[$f] = $tableIdi[$f][$i];
    }
   }
  }
  elseif ($condition == 1) { // Et logique sur critères d'une même fiche 
// recherche du premier critère renseigné
   for ($i=0;$i<$imax;$i++) {
    if (isset($tableIdi[$f][$i])) {
     $i1 = $i;
     break;
    }
   }
   $tableId[$f] = $tableIdi[$f][$i1];
   if ($i1<$imax-1) {
    $i1++;
    for ($i=$i1;$i<$imax;$i++) {
    if (isset($tableIdi[$f][$i]) && count($tableIdi[$f][$i]) > 0 ) {
      $tableId[$f] = array_intersect($tableId[$f],$tableIdi[$f][$i]);
     }
    }
   }
  }
////if ($f == 0) { echo '<br><br> tableId[0] '; print_r($tableId[0]); }
////if ($f == 1) { echo '<br><br> tableId[1] '; print_r($tableId[1]); } 
// Elimine les doublons éventuels et reconstruit les clés ordonnées des fiches
  if (count($tableId[$f]) > 0) {
   $tableId[$f] = array_unique($tableId[$f]);			// élimine doublons éventuels
   $tableId[$f] = array_values($tableId[$f]);
   $imaxId = count($tableId[$f]);
  }
  else {
   $imaxId = 0;
  }
// Remonte sur les fiches amont, si nécessaire et s'il y en a
  if ($imaxId > 0) {
   $tableIda[$f] = array();
   $d = 0;
   for ($i=0;$i<$imaxId;$i++) {
    $options = selectCompose($bdd,$tableId[$f][$i]);	  // recherche les IdCompose (=Id de fiche)  dans relation
    if ($options != "") {
     $nboptions = count($options);
     for ($o=0;$o<$nboptions;$o++) {
      $tableIda[$f][$d] = $options[$o][0];
      $d++;
     }
    }
   }
  }
// Elimine les doublons éventuels et reconstruit les clés ordonnées des fiches amont
  if (count($tableIda[$f]) > 0) {			// si trouvé au moins une fiche amont
   $tableIda[$f] = array_unique($tableIda[$f]);		// élimine doublons éventuels
   $tableIda[$f] = array_values($tableIda[$f]);
   $imaxa = count($tableIda[$f]);
  }
  else							// sinon garde les fiches aval
   $tableIda[$f] = $tableId[$f];
  if ($autrefiche) $f++;
  else {
   $tableIda[1] = array();
   break;
  }
 } 
////echo '<br><br>TableIda[0] '; print_r($tableIda[0]);
////echo '<br><br>TableIda[1] '; print_r($tableIda[1]);

// fait la réunion ou l'intersection logique des deux types de fiches
  if ($condition == 0) 
   $tableId = array_merge($tableIda[0],$tableIda[1]);
  elseif ($condition == 1)
   if (count($tableIda[0]) == 0)
    $tableId = $tableIda[1];
   elseif (count($tableIda[1]) == 0)
     $tableId = $tableIda[0];
   else
    $tableId = array_intersect($tableIda[0],$tableIda[1]);

// Elimine les doublons éventuels et reconstruit les clés ordonnées  
 $tableId = array_unique($tableId);			// éliminer doublons éventuels
 $tableId = array_values($tableId);
 $imaxf = count($tableId);
////echo '<br><br>imaxf='.$imaxf.' tableId '; print_r($tableId);
 if ($imaxf > 0) {					// si au moins une fiche trouvée 
// affichage du tableau html des fiches trouvées
   echo r2ficheLegende;  
   echo '<table border="1">';				// dans un tableau html  
   $nbcol = 15;
   $nblig = Intval($imaxf/$nbcol);
   $modulo = $imax%$nbcol;
   if ($modulo != 0) $nblig++;
   $i=0;
//   echo '<br>nblib='.$nblig.' modulo='.$modulo;
   for ($lig=0;$lig<$nblig;$lig++) {
    echo '<tr>';
    for ($col=0;$col<$nbcol;$col++) {
     if ($i<$imaxf) {
      $n = $i+1;
      $nomgenerique = "fiche ".$n.' '.$tableId[$i];
      echo '<td><a href="m2fiche.php?fiche='.$tableId[$i].'" target="_blank">'.$nomgenerique.'</a></td>';
      $i++;
      if ($i == $imaxf) {
       echo '</tr><td> ... </td><tr>';
      }
     }
    }
    echo '</tr>';
   }   
   echo '</table><hr>';
   $mesrep = $imaxf.r2ficheTrouves;		// nombre des fiches trouvées
  } 
  else {
   $mesrep = r2ficheAucun;			// aucune fiche trouvée
  }
 $_POST['message'] = $mesrep;							// informe l'utilisateur
} // fin if isset valid

// sous programme d'affichage du message de retour ou d'erreur
function afficheMessage() {
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
}


// affiche ou ré-affiche le formulaire de saisie des données
// ---------------------------------------------------------
 echo '<form method="POST" action="r2fiche.php">';
if (isset($_GET['fiche'])) {			// lancement avec paramètre n° de fiche
 $_POST['idfiche'] = $_GET['fiche'];
}
if (count($_POST) == 0 ) {			// lancement initial sans paramètre			
 echo r2ficheTitre;
 $tabl = selectObjet($bdd,$IdRacFic,'%',0); 	// recherche des fiches de la racine des objets (vcard = NULL)
 $imax = count($tabl);
 for ($i=0;$i<$imax;$i++) {			// construit table des options du sélect
  $options[$i][0] = $tabl[$i][0];
  $options[$i][1] = $tabl[$i][1];
 }
 echo '<table><tr>';
 afficheRangTable(r2ficheChoix,'fiche','select','80',$options,'','');	// affiche champ sélection d'un type de fiche
 echo '</tr></table><br>';
 afficheMessage();
 $valider = r2ficheValider;
 echo '<hr><input type="submit" name="choix" value="'.$valider.'" />';	// affiche bouton submit de choix d'un type (choix)
}
else {						// affiche champs de la fiche
// $fiches = selectId($bdd,$_POST['fiche']);// Recherche son libellé
// $_SESSION['libfiche'] = $fiches[3];
 echo r2ficheTitre1;	// pour le type de fiche sélectionné
 echo r2ficheGuide1;
  $mode = 0; 					// mode recherche
  $c = 0;					// pointeur des couples(mode=0) du $_POST
  if (isset($_SESSION['idfiche'])) {
   echo '<table>';
   afficheForme($bdd,$_SESSION['idfiche'],$mode,0);	// affiche labels et champs de la fiche sélectionnée
   echo '</tr><tr>';
   // Recherche avec ou sans casse
   $casses[0][0] = 0;
   $casses[0][1] = "Non";
   $casses[1][0] = 1;
   $casses[1][1] = "Oui";
   if (isset($casse))
    $casses[0][2] = $casse;
   else
    $casse = '';
   afficheRangTable(r2ficheCasse,'casse','select','80',$casses,'','');
   echo '</tr><tr>';
   // Recherche avec condition
   $conditions[0][0] = 0;
   $conditions[0][1] = "Ou logique";
   $conditions[1][0] = 1;
   $conditions[1][1] = "Et logique";
   if (isset($condition))
    $conditions[0][2] = $condition;
   else
    $condition = '';
   afficheRangTable(r2ficheBooleen,'condition','select','80',$conditions,'','');
   echo '</tr></table>';
  }
  echo '<br>'; afficheMessage();
  $rechercher = r2ficheRechercher;
  echo '<hr><input type="submit" name="recher" value="'.$rechercher.'" />';	// affiche bouton de recherche 
							
}
?>
 <script>
  document.getElementById('texte0').focus();
 </script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
