<?php 
/* But de ce programme: Créer un utilisateur
   Profil: Administrateur
*/
session_start();	// démarre la session
include('lib/ban-menu.php'); // inclue menu et son traitement
include('lib/lib.php'); // inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase();	// ouvre la base de données biblio;
autorise(array(9));	// contrôle accès administrateur

// traite la demande de création
if (isset($_POST['email']) AND isset($_POST['envoi']) ){	
//print_r($_POST);
 $message = "";
 $nom = $_POST['nom'];
 $prenom = $_POST['prenom'];
 $email = $_POST['email'];
 $passe = md5($_POST['passe']);
 $profil = $_POST['profil'];
 $trouve = FALSE;
 $id = 0;
 $donnee = 0;
 if (verifEmail($email)) { 
  // recherche existence de cette adresse email dans usager
  $donnees = selectUsager($bdd,$email);
  if ($donnees == 0) {		// si non trouvé, créer l'utilisateur  
   $id = insertUsager($bdd,$nom,$prenom,$email,$passe,$profil);
   if ($id == 0)
    $message = "Erreur ! Incident création";
   else
    $message = 'Création utilisateur réussie';
  }
  else {	// si trouvé, erreur
   $message = "Erreur ! Un utilisateur avec cet email existe déjà !";
  }
 }
 else {
  $message = "Adresse email incorrecte.";
 }
 $passe = ""; // ne pas rafficher le passe
}

// envoi le formulaire de saisie
echo '<form method="POST" action="s1login.php">';
echo '<h3> Saisie d\'un nouvel utilisateur</h3>';
afficheChamp(' Nom _______ ','nom','text','30',$nom,'','');
afficheChamp(' Prénom ____ ','prenom','text','30',$prenom,'','');
afficheChamp(' Email ______ ','email','text','40',$email,'','');
afficheChamp(' Mot de passe ','passe','text','30',$passe,'','');
afficheChamp(' Profil ______ ','profil','text','5',$profil,'','');
echo '<br>';
afficheChamp('','message','text','80',$message,'','Readonly');
echo '<input type="submit" name="envoi" value="Envoyer">';
?>
<html>
</html>
