<?php
// Erreurs, anomalies, remarques
/* **** utiliser $data = htmlentities($_POST[]) pour protéger des attaques Html
Pas de solution implémentée 
** Revoir type à saisir par select et coder select en table objet_type; incidence sur autres programmes !
types possibles: texte, date, nombre, mail, ... pour l'instant texte seulement
type interdit: fiche (réservé pour fiche générique et occ. fiches
*/

/* But de ce programme: Définir un nouveau type ou modèle d'objet
 Il s’agit de créer :
 une occurrence générique objet dont le père est la racine de tous les objets
 et une occurrence objet_type de même Id qui contient toutes les propriétés de l'objet générique
 fonctions utilisées: ouvreBase, autorise, initBase, existObjetInvisible, afficheChamp, selectTable		
*/

if (!isset($_SESSION)) session_start(); 		// démarre la session
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé par les profils Aministrateur et Gestionnaire
autorise(array(5,9));					// contrôle accès
initBase($bdd);			// récup $IdRacGen, $IdRacObj, $IdRacFic et $IdRacRel

DEFINE ('s1objetExiste','Erreur ! '.$_POST['texte0'].' est un type d\'objet qui existe déjà');
DEFINE ('s1objetNonFiche','Erreur ! type de la donnée générique ne peut être fiche !');
DEFINE ('s1objetOK','Objet générique ');
DEFINE ('s1objetOK1',' bien enregistré.');
DEFINE ('s1objetKO','Erreur ! Rien n\'a été enregistré !');
DEFINE ('s1objetTitre','<h4>Création nouveau type d\' objet</h4>');
DEFINE ('s1objetGuide','<p>Saisir nom de l\'objet modèle ou générique (nouveau, unique); <br/>puis sa taille et son type.<br/>Enfin appuyer sur le bouton Créer type objet.<br/></p>');
DEFINE ('s1objetLibel','Libellé ');

// si Submit effectué et 1er champ du formulaire renseigné
// -------------------------------------------------------
if (isset($_POST['valid']) AND isset($_POST['texte0']) AND $_POST['texte0'] != NULL ) {	
 $poubelle = array_pop($_POST); 			// éliminer le post du valid
 $poubelle = array_pop($_POST); 			// éliminer le post du message
// print_r($_POST);
 $cle = existObjetInvisible($bdd,$IdRacObj,$_POST['texte0']);	// objet générique existe déjà ?
 if ($cle != 0) {
  $_POST['message'] = s1objetExiste;// informe l'utilisateur
 }
 elseif ($_POST['texte4'] == "fiche") {
  $_POST['message'] = s1objetNonFiche;
 }
 else {
  try {								// début essai traitement
   $bdd->beginTransaction(); 					// ouvre une transaction
// crée nouveau type d'objet (ou objet générique) et note son Id; 
   $libelle = $_POST['texte0'];
   $idobjet = insertObjet($bdd,$IdRacObj,$libelle,0);
// crée nouvel objet_type associé (même Id) (unicite_max forcé à 1
   insertObjetType($bdd,$idobjet,$_POST['texte1'],1,$_POST['texte3'],$_POST['texte4']);
   $bdd->commit(); 						// valide et termine la transaction	
   $_POST['message'] = s1objetOK.$libelle.s1objetOK1;// informe l'utilisateur
  }
  catch(Exception $e) {						// si incident durant l'essai
   $bdd->rollback();						// invalide la transaction
   $_POST['message'] = s1objetKO;	// informe l'utilisateur
  }
 } 								// fin essai traitement
}

// affiche ou ré-affiche le formulaire de saisie des données
 echo '<form method="POST" action="s1objet.php">';
 echo s1objetTitre;
 echo s1objetGuide;
/* affiche champs de saisie selon description de l'objet et d'objet_type
 Id		généré par la base de données
 Id_Pere	= $IdRacObj
 Texte		signification de l'objet générique nouveau (à saisir doit être unique)
 size		taille du texte objet
 type		type de l'objet
 */
 echo '<table>';
 afficheRangTable(s1objetLibel,'texte0','text','80','','','');
 // retrouve le nom et type des champs de la table objet_type 
 $sql = "Show columns from objet_type ;";
 $nomChamps = selectTable($bdd,$sql);
 $rmax = count($nomChamps);
 // affiche les données à saisir
 for ($r=1;$r<$rmax;$r++) {
  if (substr($nomChamps[$r][1],0,4) == "text" OR substr($nomChamps[$r][1],0,7) == "varchar") $size = "40";
  else $size = 5;
  if ($r != 2)	{// ne pas afficher unicite_max (présent en table objet_type mais inutilisé)
   if ($r == 1) {
    $initialisation = 1;
    $typed = "text";
   }
   if ($r == 3) {
    $initialisation = 50;
    $typed = "text";
   }
   if ($r == 4) {
    $initialisation = initialiseTypes();
    $typed = "select";
   }
   echo '<tr>';
   afficheRangTable($nomChamps[$r][0].' ','texte'.$r,$typed,$size,$initialisation,'','');
   echo '</tr>';
  }
 }
 echo '</table><br>';
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 echo '<hr><input type="submit" name="valid" value="Créer type objet" />';
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
